process end_level_event_image (x,y,z,file,graph)
begin
    signal(id,s_freeze);
    frame;
end

process end_level_event (level)
private
    int hijos[3];
begin
    prota_control=false;
    pausa_estado=0;
    level_song=105;
    
    graph=new_map(320,240,16);
    map_clear(file,graph,1);
    x=160;
    y=120;
    z=-10;
    alpha=0;
    info_prota.id_prota.z=z-1;
    
    for (alpha=0;alpha<255;alpha+=5) frame; end
    if (alpha>255) alpha=255; end
    
    if (level==1)
        if (savegame_pos!=0)
            refresh_actual_gamedata(&game_global_sav);
            save_filegame(&game_global_sav,savegame_pos);
            game_saved_graph();
        end
    end
    
    enem_grafs[0][cte_event]=load_fpg("grafs/chlevel.fpg");
    enem_grafs[1][cte_event]=true;
    
    //musica
    frame(15000);
    hijos[0]=end_level_event_image(83,25,z-1,enem_grafs[0][cte_event],20);
    frame(2500);
    hijos[1]=end_level_event_image(237,25,z-1,enem_grafs[0][cte_event],21);
    frame(2500);
    hijos[2]=end_level_event_image(160,55,z-1,enem_grafs[0][cte_event],22);
    frame(5000);
    hijos[3]=end_level_event_image(160,133,z-1,enem_grafs[0][cte_event],level);
    //echo has passed castle horror
    
    while (is_playing_song()) frame; end
    //loop frame; end
    
    set_fps(25,cte_frameskip);
    fade(0,0,0,1);
    while (fading) frame; end
    set_fps(50,cte_frameskip);
    
    signal(hijos[0],s_kill);
    signal(hijos[1],s_kill);
    signal(hijos[2],s_kill);
    signal(hijos[3],s_kill);
    unload_map(file,graph);
    unload_fpg(enem_grafs[0][cte_event]);
    enem_grafs[1][cte_event]=false;
end

process dead_event ()
private
    int angle2;
    int de_echo;
    int de_espiritu;
    int de_vidas[4];
    
    int de_animacion[14]=36,36,36,36,36,36,36,36,37,36,37,36,36,36,36;
    
    //int temp_prota_graph;
    int temp_level_song;
    int cont;
    
begin
    prota_control=false;
    pausa_estado=0;
    if (exists(info_prota.id_prota)) signal(info_prota.id_prota,s_freeze); end
    signal_items(s_freeze);
    signal_enemigos(s_freeze);
    signal_event_all(s_freeze);
    
    temp_level_song=level_song;
    level_song=0;
    
    graph=new_map(320,240,16);
    map_clear(file,graph,1);
    x=160;
    y=120;
    z=-99;
    alpha=0;
    //info_prota.id_prota.z=-4;
    //info_prota.id_prota.graph=4;
    //temp_prota_graph=info_prota.id_prota.graph;
    //info_prota.id_prota.graph=0;
    if (exists(info_prota.id_prota)) signal(info_prota.id_prota,s_sleep); end
    de_echo=end_level_event_image(info_prota.id_prota.x,info_prota.id_prota.y,-100,info_prota.id_prota.file,20);
    
    for (alpha=0;alpha<200;alpha+=5) frame; end
    if (alpha>200) alpha=200; end
    
    while ((de_echo.x!=160) || (de_echo.y!=185))
        if (de_echo.x<160) de_echo.x++; end
        if (de_echo.x>160) de_echo.x--; end
        if (de_echo.y<185) de_echo.y++; end
        if (de_echo.y>185) de_echo.y--; end
        frame;
    end
    
    de_echo.graph=35;
    frame(5000);
    enem_grafs[0][cte_dead]=load_fpg("grafs/gover.fpg");
    enem_grafs[1][cte_dead]=true;
    de_espiritu=end_level_event_image(de_echo.x,de_echo.y,-100,enem_grafs[0][cte_dead],1);
    de_espiritu.alpha=0;
    
    while (de_espiritu.y>-15)
        de_espiritu.y--;
        if (de_espiritu.alpha<255) de_espiritu.alpha+=5; end
        angle2+=6000;
        if (angle2>360000) angle2-=360000; end
        de_espiritu.x=160+(17*sin(angle2));
        frame;
    end
    
    for (cont=0;cont<info_prota.vidas;cont++)
        de_vidas[cont]=end_level_event_image(150-(22*(info_prota.vidas-1))+(44*cont),
                                             -16,-100,enem_grafs[0][cte_dead],3);
    end
    
    while (de_vidas[0].y<70)
        for (cont=0;cont<info_prota.vidas;cont++)
            de_vidas[cont].y++;
        end
        frame;
    end
    frame(5000);
    
    for (cont=4;cont<=8;cont++)
        de_vidas[info_prota.vidas-1].graph=cont;
        frame(300);
    end
    de_vidas[info_prota.vidas-1].graph=0;
    signal(de_vidas[info_prota.vidas-1],s_kill);
    frame(5000);
    
    
    info_prota.vidas--;
    
    
    if (info_prota.vidas==0)
        //animacion de la muerte, etc
        level_song=106;
        
        for (alpha=200;alpha<255;alpha+=5) frame; end
        if (alpha>255) alpha=255; end
        
        //game over
        de_espiritu.x=160;
        de_espiritu.y=-15;
        de_espiritu.graph=9;
        while (de_espiritu.y<70) de_espiritu.y++; frame; end
        
        while (is_playing_song()) frame; end
        frame(10000);
        fade(0,0,0,2);
        while (fading) frame; end
        signal(de_espiritu,s_kill);
        signal(de_echo,s_kill);
        next_level=0;
        global_mode=0;
        end_level=true;
        frame;
    else
        for (cont=0;cont<=14;cont++)
            de_echo.graph=de_animacion[cont];
            frame(500);
        end
        de_echo.graph=1;
        frame(5000);
        de_echo.graph=15;
        
        while (de_vidas[0].x<350)
            for (cont=0;cont<info_prota.vidas;cont++)
                de_vidas[cont].x+=5;
            end
            frame;
        end
        
        for (cont=0;cont<5;cont++)
            if (exists(de_vidas[cont])) signal(de_vidas[cont],s_kill); end
        end
        frame(5000);
        de_echo.graph=2;
        frame(2500);
        
        de_espiritu.x=160;
        de_espiritu.y=-100;
        de_espiritu.graph=2;
        cont=0;
        while (de_espiritu.y<de_echo.y)
            de_espiritu.y+=2;
            de_espiritu.angle+=9000;
            de_espiritu.alpha=(de_echo.y-de_espiritu.y)*2;
            if (de_espiritu.alpha>255) de_espiritu.alpha=255; end
            cont++;
            switch (cont)
            case 3: de_echo.graph=38; end
            case 6: de_echo.graph=39; cont=0; end
            end //switch
            
            frame;
        end
        
        signal(de_espiritu,s_kill);
        de_echo.graph=2;
        frame(1000);
        de_echo.graph=1;
        frame(10000);
        de_echo.graph=30;
        frame(2500);
        
        while ((de_echo.x!=info_prota.id_prota.x) || (de_echo.y!=info_prota.id_prota.y))
            if (de_echo.x<info_prota.id_prota.x) de_echo.x++; end
            if (de_echo.x>info_prota.id_prota.x) de_echo.x--; end
            if (de_echo.y<info_prota.id_prota.y) de_echo.y++; end
            if (de_echo.y>info_prota.id_prota.y) de_echo.y--; end
            frame;
        end
        
        //loop frame; end
        de_echo.graph=info_prota.id_prota.graph;
    
        info_prota.p_energ=info_prota.p_max_energ;
        refresh_interface();
        for (alpha=200;alpha>0;alpha-=5) frame; end
        if (alpha<0) alpha=0; end
        
        signal(de_echo,s_kill);
        if (exists(info_prota.id_prota)) signal(info_prota.id_prota,s_wakeup); end
        signal_items(s_wakeup);
        signal_enemigos(s_wakeup);
        signal_event_all(s_wakeup);
        prota_control=true;
        pausa_estado=1;
        level_song=temp_level_song;
        
        frame;
    end
    
    unload_fpg(enem_grafs[0][cte_dead]);
    enem_grafs[1][cte_dead]=false;
    unload_map(file,graph);
end
    
//************************************************************************************
//************************************************************************************
//      BOSSES
//************************************************************************************
//************************************************************************************

process croquis (x2,y2, int vel_horiz, int vel_vert, int croquis_max_vel)
private
    //int vel_horiz, vel_vert;
    //int croquis_max_vel;
    int cont_anim;
    int temp;
    int temp_espada;
begin
    priority=father.priority-1;
    resolution=100;
    x=x2*resolution;
    y=y2*resolution;
    alpha=0;
    file=father.file;
    cont_anim=4;
    energia=24;
    //croquis_max_vel=220;
    //say("velocidad: "+itoa(croquis_max_vel));
    while (graph!=52)
        if (alpha<254) alpha+=2; else alpha=255; end
        if ((father.x+20)<x2)
            vel_horiz-=8;
            if (vel_horiz<-croquis_max_vel) vel_horiz=-croquis_max_vel; end
        end
        if ((father.x-20)>x2)
            vel_horiz+=8;
            if (vel_horiz>croquis_max_vel) vel_horiz=croquis_max_vel; end
        end
        if ((father.y+20)<y2)
            vel_vert-=8;
            if (vel_vert<-croquis_max_vel) vel_vert=-croquis_max_vel; end
        end
        if ((father.y-20)>y2)
            vel_vert+=8;
            if (vel_vert>croquis_max_vel) vel_vert=croquis_max_vel; end
        end
        
        if (vel_horiz>0) flags=0; end
        if (vel_horiz<0) flags=1; end
        
        x+=vel_horiz;
        y+=vel_vert;
        x2=x/resolution;
        y2=y/resolution;
        
        //zona de graficos
        cont_anim++;
        switch (cont_anim)
        case 5: graph=51; end
        case 10: graph=50; cont_anim=0; end
        end //switch
        
        //**************************************
        //  ZONA DE IMPACTOS
        //**************************************
        //impacto con las balas
        temp=collision(type normal_shot);
        while (temp)
            energia-=temp.energia;
            //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
            //say("el disparo tena energia: "+itoa(temp.energia));
            temp.energia=0;
            if (mi_temblor!=0 && exists(mi_temblor))
                mi_temblor.energia=3;
            else
                mi_temblor=enem_temblor(id,3);
            end
            temp=collision(type normal_shot);
        end
        temp=collision(type espadazo);
        if (temp && (temp!=temp_espada))
            energia-=temp.energia;
            if (mi_temblor!=0 && exists(mi_temblor))
                mi_temblor.energia=3;
            else
                mi_temblor=enem_temblor(id,3);
            end
            temp_espada=temp;
        end
        if (energia<=0) break; end
        
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=2;
                info_prota.dano_exp=2;
                if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                else info_prota.dano_vel_horiz=-20;
                end
            end
        end
        
        frame;
    end
    
    if (energia>0)
        //se est lanzando
        if (exists(info_prota.id_prota))
            angle=fget_angle(x2,y2,info_prota.id_prota.x,info_prota.id_prota.y);
            flags=0;
        end
        
        loop
            advance(400);
            if (out_region(id,0)) break; end
            
            //impacto con el prota
            if (exists(info_prota.id_prota))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=4;
                    info_prota.dano_exp=2;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
            
            frame;
        end
    end
end

process ghyppo_head (x,y,z,file,alpha)
private
    int temp;
    int temp_espada;
begin
    graph=2;
    //size=200;
    loop
        //ZONA DE COLISIONES
        //say(itoa(alpha));
        if (alpha==255)
            //impacto con las balas
            temp=collision(type normal_shot);
            while (temp)
                father.energia-=temp.energia+1;
                temp.energia=0;
                temp=collision(type normal_shot);
            end
            temp=collision(type espadazo);
            if (temp && (temp!=temp_espada))
                father.energia-=temp.energia+1;
                temp_espada=temp;
            end
            
            //impacto con el prota
            if (exists(info_prota.id_prota))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=2;
                    info_prota.dano_exp=2;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
        end
        
        frame;
    end
end
process ghyppo_tail (z,file,alpha)
private
    int temp;
    int temp_espada;
begin
    graph=3;
    //size=200;
    loop
        //ZONA DE COLISIONES
        //say(itoa(alpha));
        if (alpha==255)
            //impacto con las balas
            temp=collision(type normal_shot);
            while (temp)
                father.energia-=temp.energia/2;
                temp.energia=0;
                temp=collision(type normal_shot);
            end
            temp=collision(type espadazo);
            if (temp && (temp!=temp_espada))
                father.energia-=temp.energia/2;
                temp_espada=temp;
            end
            
            //impacto con el prota
            if (exists(info_prota.id_prota))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=2;
                    info_prota.dano_exp=2;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
        end
        frame;
    end
end
process ghyppo_bomb (z,file)
begin
    while (graph!=22)
        frame;
    end
    //se est lanzando
    if (exists(info_prota.id_prota))
        angle=fget_angle(x,y,info_prota.id_prota.x,info_prota.id_prota.y);
        flags=0;
    end
    
    resolution=100;
    x*=resolution;
    y*=resolution;
    loop
        advance(900);
        if (out_region(id,0)) break; end
        
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=8;
                info_prota.dano_exp=4;
                if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                else info_prota.dano_vel_horiz=-20;
                end
            end
        end
        
        frame;
    end
end


process ghyppo (file)
private
    int ghyppo_head_id;
    int ghyppo_tail_id;
    int ghyppo_bomb_id;
    int ghyppo_croquis[9];
    int num_croquis;
    int cont_croquis;
    
    int angle2;     //para el movimiento de flotacin
    int angle3;     //para el recolocamiento de las partes
    int head_offsx,head_offsy;
    int tail_offsx,tail_offsy;
    
    int energia_ant;
    int ghyppo_temblor[2];
    
    int x3,y3;
    int vel_horiz, vel_vert;
    int enem_estado;    //0: moviendo derecha
                        //1: moviendo invisible derecha
                        //2: moviendo izquierda
                        //3: moviendo invisible izquierda
                        //4: ataque croquis
                        //5: ataque bomba
                        //6: ataque lanzamiento
    int enem_estado2;
                        
    int ghyppo_posv[2]=68,124,180;
    int ghyppo_dir;
    
    int cont;
    int cont_estado;
    int temp_x,temp_y;
    int temp;   //buscar en zona de colisiones
    int temp_espada;
begin
    x3=32;
    y3=68;
    z=5;
    alpha=0;
    graph=1;
    //size=200;
    angle3=90000;
    
    energia=600;
    energia_ant=energia;
    
    //x3,y3 indican la posicin donde debera estar
    //x2,y2 indica en la que estn, contando con movimiento de flotacin
    //x ,y  es la posicin real, contando flotacin e impacto
    x2=x3;
    y2=y3;
    x=x3;
    y=y3;
    
    ghyppo_head_id=ghyppo_head(x,y-24,z-1,file,alpha);
    ghyppo_tail_id=ghyppo_tail(z+1,file,alpha);
    head_offsx=0;
    head_offsy=-24;
    tail_offsx=-14;
    tail_offsy=16;
    ghyppo_tail_id.x=x2+tail_offsx;
    ghyppo_tail_id.y=y2+tail_offsy;
    
    for (alpha=0;alpha<=255;alpha++)
        angle2+=3000;
        if (angle2>360000) angle2-=360000; end
        y2=y3+(4*sin(angle2));
        y=y2;
        ghyppo_head_id.alpha=alpha;
        ghyppo_head_id.y=y2+head_offsy;
        ghyppo_tail_id.alpha=alpha;
        ghyppo_tail_id.y=y2+tail_offsy;
        frame;
    end
    
    alpha=255;
    
    while (num_croquis<10)
        cont++;
        if (cont==25)
            cont=0;
            ghyppo_croquis[num_croquis]=croquis(rand(x-35,x+35),rand(y-40,y+40),5,5,rand(250,170));
            num_croquis++;
        end
        angle2+=3000;
        if (angle2>360000) angle2-=360000; end
        y2=y3+(4*sin(angle2));
        y=y2;
        ghyppo_head_id.alpha=alpha;
        ghyppo_head_id.y=y2+head_offsy;
        ghyppo_tail_id.alpha=alpha;
        ghyppo_tail_id.y=y2+tail_offsy;
        frame;
    end
    
    prota_control=true;
    
    while (energia>0)
        //say("cont estado: "+itoa(cont_estado));
        //say("numero croquis: "+itoa(num_croquis));
        switch (enem_estado)
        case 0:
            if (cont_estado<200)
                cont_estado++;
                if (cont_estado==200) ghyppo_dir=rand(0,2); end
            else
                if (x3<285)//273)
                    /*if (y3<ghyppo_posv[ghyppo_dir]) 
                        vel_vert++;
                        if (vel_vert>3) vel_vert=3; end
                    end
                    if (y3>ghyppo_posv[ghyppo_dir]) 
                        vel_vert--;
                        if (vel_vert<-3) vel_vert=-3; end
                    end*/
                    /*vel_vert=ghyppo_posv[ghyppo_dir]-y3;
                    if (vel_vert>1) vel_vert=1; end
                    if (vel_vert<-1) vel_vert=-1; end*/
                    if (y3<ghyppo_posv[ghyppo_dir]) vel_vert=1;
                    elsif (y3>ghyppo_posv[ghyppo_dir]) vel_vert=-1;
                    else vel_vert=0; end
                    vel_horiz++;
                    if (vel_horiz>2) vel_horiz=2; end
                else
                    if (vel_horiz>0)
                        vel_horiz--;
                    else
                        ghyppo_head_id.flags=1;
                        ghyppo_tail_id.flags=1;
                        tail_offsx=14;
                        enem_estado=rand(4,6);
                        //enem_estado=rand(2,3);
                        //enem_estado=6;
                        enem_estado2=0;
                        cont_estado=0;
                    end
                end
                x3+=vel_horiz;
                y3+=vel_vert;
            end
        end
        case 2:
            if (cont_estado<200)
                cont_estado++;
                if (cont_estado==200) ghyppo_dir=rand(0,2); end
            else
                if (x3>35)//47)
                    /*if (y3<ghyppo_posv[ghyppo_dir]) 
                        vel_vert++;
                        if (vel_vert>3) vel_vert=3; end
                    end
                    if (y3>ghyppo_posv[ghyppo_dir]) 
                        vel_vert--;
                        if (vel_vert<-3) vel_vert=-3; end
                    end*/
                    /*vel_vert=ghyppo_posv[ghyppo_dir]-y3;
                    if (vel_vert>2) vel_vert=2; end
                    if (vel_vert<-2) vel_vert=-2; end*/
                    if (y3<ghyppo_posv[ghyppo_dir]) vel_vert=1;
                    elsif (y3>ghyppo_posv[ghyppo_dir]) vel_vert=-1;
                    else vel_vert=0; end
                    vel_horiz--;
                    if (vel_horiz<-2) vel_horiz=-2; end
                else
                    if (vel_horiz<0)
                        vel_horiz++;
                    else
                        ghyppo_head_id.flags=0;
                        ghyppo_tail_id.flags=0;
                        tail_offsx=-14;
                        enem_estado=rand(4,6);
                        //enem_estado=rand(0,1);
                        //enem_estado=6;
                        enem_estado2=0;
                        cont_estado=0;
                    end
                end
                x3+=vel_horiz;
                y3+=vel_vert;
            end
        end
        case 1:
            if ((alpha>0) && (cont_estado==0))
                alpha--;
                ghyppo_head_id.alpha=alpha;
                ghyppo_tail_id.alpha=alpha;
                if (alpha==0) cont_estado=1; end
            end
            if ((alpha<255) && (cont_estado==2))
                alpha++;
                ghyppo_head_id.alpha=alpha;
                ghyppo_tail_id.alpha=alpha;
                if (alpha==255)
                    cont_estado=0;
                    enem_estado=rand(4,6);
                    //enem_estado=rand(2,3);
                    //enem_estado=6;
                    enem_estado2=0;
                end
            end
            if (cont_estado==1)
                if (x3<285)//273)
                    if (y3<ghyppo_posv[ghyppo_dir]) vel_vert=1;
                    elsif (y3>ghyppo_posv[ghyppo_dir]) vel_vert=-1;
                    else vel_vert=0; end
                    vel_horiz++;
                    if (vel_horiz>2) vel_horiz=2; end
                else
                    if (vel_horiz>0)
                        vel_horiz--;
                    else
                        ghyppo_head_id.flags=1;
                        ghyppo_tail_id.flags=1;
                        tail_offsx=14;
                        cont_estado=2;
                    end
                end
                x3+=vel_horiz;
                y3+=vel_vert;
            end
        end
        case 3:
            if ((alpha>0) && (cont_estado==0))
                alpha--;
                ghyppo_head_id.alpha=alpha;
                ghyppo_tail_id.alpha=alpha;
                if (alpha==0) cont_estado=1; end
            end
            if ((alpha<255) && (cont_estado==2))
                alpha++;
                ghyppo_head_id.alpha=alpha;
                ghyppo_tail_id.alpha=alpha;
                if (alpha==255)
                    cont_estado=0;
                    enem_estado=rand(4,6);
                    //enem_estado=rand(0,1);
                    //enem_estado=6;
                    enem_estado2=0;
                end
            end
            if (cont_estado==1)
                if (x3>35)//47)
                    /*if (y3<ghyppo_posv[ghyppo_dir]) 
                        vel_vert++;
                        if (vel_vert>3) vel_vert=3; end
                    end
                    if (y3>ghyppo_posv[ghyppo_dir]) 
                        vel_vert--;
                        if (vel_vert<-3) vel_vert=-3; end
                    end*/
                    /*vel_vert=ghyppo_posv[ghyppo_dir]-y3;
                    if (vel_vert>2) vel_vert=2; end
                    if (vel_vert<-2) vel_vert=-2; end*/
                    if (y3<ghyppo_posv[ghyppo_dir]) vel_vert=1;
                    elsif (y3>ghyppo_posv[ghyppo_dir]) vel_vert=-1;
                    else vel_vert=0; end
                    vel_horiz--;
                    if (vel_horiz<-2) vel_horiz=-2; end
                else
                    if (vel_horiz<0)
                        vel_horiz++;
                    else
                        ghyppo_head_id.flags=0;
                        ghyppo_tail_id.flags=0;
                        tail_offsx=-14;
                        cont_estado=2;
                    end
                end
                x3+=vel_horiz;
                y3+=vel_vert;
            end
        end
        case 4:
            switch (enem_estado2)
            case 0:
                cont_estado++;
                if (cont_estado==200)
                    cont_croquis=0;
                    enem_estado2=1;
                    cont_estado=0;
                    num_croquis=9;
                    //say("numero croquis inicial: "+itoa(num_croquis));
                end
            end
            case 1:
                cont_estado++;
                if (cont_estado==50)
                    cont_estado=0;
                    if (cont_croquis<=9)
                        if (exists(ghyppo_croquis[cont_croquis]))
                            ghyppo_croquis[cont_croquis].graph=52;
                        else
                            if (num_croquis>=0) num_croquis--; end
                            cont_estado=49;
                            //say("croquis no contado: "+itoa(cont_croquis));
                            //say("quedan: "+itoa(num_croquis));
                        end
                        cont_croquis++;
                    else
                        enem_estado2=2;
                        cont_croquis=0;
                        cont_estado=0;
                        if (num_croquis<9) num_croquis++; end
                    end
                end
            end
            case 2:
                cont_estado++;
                if (cont_estado==25)
                    cont_estado=0;
                    //say("numero final de croquis: "+itoa(num_croquis));
                    if (cont_croquis<=num_croquis)
                        ghyppo_croquis[cont_croquis]=croquis(rand(x-35,x+35),rand(y-40,y+40),5,5,rand(250,170));
                        cont_croquis++;
                    else
                        cont_croquis=0;
                        enem_estado2=0;
                        cont_estado=0;
                        if (x>160) enem_estado=rand(2,3); else enem_estado=rand(0,1); end
                     end
                end
            end
            end //switch
        end
        case 5:
            switch (enem_estado2)
            case 0:     //generando la bomba
                cont_estado++;
                switch (cont_estado)
                case 150:
                    ghyppo_bomb_id=ghyppo_bomb(z-1,file);
                    ghyppo_bomb_id.graph=20;
                end
                case 200: ghyppo_bomb_id.graph=21; end
                case 250:
                     ghyppo_bomb_id.graph=22;
                     enem_estado2=1;
                end
                end //switch
            end
            case 1:     //esperando a que desaparezca la bomba
                if (!exists(ghyppo_bomb_id))
                    enem_estado2=0;
                    cont_estado=0;
                    if (x>160) enem_estado=rand(2,3); else enem_estado=rand(0,1); end
                end
            end
            end //switch
        end
        case 6:
            switch (enem_estado2)
            case 0:     //obteniendo postura
                angle3-=2000;
                head_offsy=-24*sin(angle3);
                head_offsx=18*cos(angle3);
                if (ghyppo_head_id.flags==1)
                    head_offsx=-head_offsx;
                    get_point(file,graph,6,&temp_x,&temp_y);
                    //say(itoa(temp_x)+" "+itoa(temp_y));
                else
                    get_point(file,graph,5,&temp_x,&temp_y);
                end
                temp_x-=21;
                temp_y-=24;
                //say(itoa(temp_x)+" "+itoa(temp_y));
                
                if (tail_offsx<temp_x) tail_offsx++; end
                if (tail_offsx>temp_x) tail_offsx--; end
                if (tail_offsy<temp_y) tail_offsy++; end
                if (tail_offsy>temp_y) tail_offsy--; end
                //say(itoa(tail_offsx)+" "+itoa(tail_offsy));
                
                if ((angle3%8000)==0) y3++; end
                
                if (angle3==0) enem_estado2=1; end
            end
            case 1:
                cont_estado++;
                if (cont_estado==25)
                    cont_estado=0;
                    enem_estado2=2;
                end
            end
            case 2:
                if (ghyppo_head_id.flags==1)
                    x3-=5;
                    if (x3<-45) enem_estado2=3; end
                else
                    x3+=5;
                    if (x3>365) enem_estado2=3; end
                end
            end
            case 3:
                angle3=90000;
                head_offsx=0;
                head_offsy=-24;
                tail_offsy=16;
                if (ghyppo_head_id.flags==1)
                    ghyppo_head_id.flags=0;
                    ghyppo_tail_id.flags=0;
                    tail_offsx=-14;
                    enem_estado2=4;
                else
                    ghyppo_head_id.flags=1;
                    ghyppo_tail_id.flags=1;
                    tail_offsx=14;
                    enem_estado2=5;
                end
                y3-=11;
            end
            case 4:
                x3++;
                if (x3==35)
                    enem_estado2=0;
                    enem_estado=rand(0,1);
                end
            end
            case 5:
                x3--;
                if (x3==285)
                    enem_estado2=0;
                    enem_estado=rand(2,3);
                end
            end
            end //switch
        end
        end //switch
        
        //if (alpha>255) alpha=255; end
        
        x2=x3;
        x=x2;
        angle2+=3000;
        if (angle2>360000) angle2-=360000; end
        y2=y3+(6*sin(angle2));
        //y2=y3;
        y=y2;
        ghyppo_head_id.alpha=alpha;
        ghyppo_head_id.x=x2+head_offsx;
        ghyppo_head_id.y=y2+head_offsy;
        ghyppo_tail_id.alpha=alpha;
        ghyppo_tail_id.x=x2+tail_offsx;
        ghyppo_tail_id.y=y2+tail_offsy;
        if (exists(ghyppo_bomb_id))
            if (ghyppo_bomb_id.graph<22)
                ghyppo_bomb_id.x=x;
                ghyppo_bomb_id.y=y;
            end
        end
        
        //ZONA DE COLISIONES
        //say(itoa(alpha));
        if (alpha==255)
            //impacto con las balas
            temp=collision(type normal_shot);
            while (temp)
                energia-=temp.energia;
                temp.energia=0;
                temp=collision(type normal_shot);
            end
            temp=collision(type espadazo);
            if (temp && (temp!=temp_espada))
                energia-=temp.energia;
                temp_espada=temp;
            end
            if (energia_ant!=energia)
                if (ghyppo_temblor[0]!=0 && exists(ghyppo_temblor[0]))
                    ghyppo_temblor[0].energia=5;
                    ghyppo_temblor[1].energia=5;
                    ghyppo_temblor[2].energia=5;
                else
                    ghyppo_temblor[0]=enem_temblor(id,5);
                    ghyppo_temblor[1]=enem_temblor(ghyppo_head_id,5);
                    ghyppo_temblor[2]=enem_temblor(ghyppo_tail_id,5);
                end
                energia_ant=energia;
            end
            //energia_ant=energia;
            if (energia<=0) break; end
            
            //impacto con el prota
            if (exists(info_prota.id_prota))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    if (enem_estado2==5)
                        info_prota.dano_energia=4;
                        info_prota.dano_exp=3;
                    else
                        info_prota.dano_energia=2;
                        info_prota.dano_exp=2;
                    end
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
        end
        
        frame;
        
    end
    
    /*loop
        angle2+=3000;
        if (angle2>360000) angle2-=360000; end
        y2=y3+(4*sin(angle2));
        y=y2;
        ghyppo_head_id.alpha=alpha;
        ghyppo_head_id.y=y2+head_offsy;
        ghyppo_tail_id.alpha=alpha;
        ghyppo_tail_id.y=y2+tail_offsy;
        frame;
    end*/
    
    fade(200,200,200,255);
    frame(300);
    fade(100,100,100,255);
    
    if (exists(ghyppo_bomb_id))
        signal(ghyppo_bomb_id,s_kill);
    end
    
    while (alpha>0)
        alpha--;
        ghyppo_head_id.alpha=alpha;
        ghyppo_tail_id.alpha=alpha;
        frame;
    end
    
    if (exists(ghyppo_head_id)) signal(ghyppo_head_id,s_kill); end
    if (exists(ghyppo_tail_id)) signal(ghyppo_tail_id,s_kill); end
    cont=get_id(type croquis);
    while (cont)
        cont.graph=52;
        cont=get_id(type croquis);
    end
end


process dragon_part (file,graph,x2,y2,z)
private
    int temp;
begin
    energia=30;
    
    switch (graph)
    case 2,3:
        loop
            if (exists(info_prota.id_prota))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=4;
                    info_prota.dano_exp=2;
                    
                    if (info_prota.id_prota.x>x) info_prota.dano_vel_horiz=30;
                    else info_prota.dano_vel_horiz=-30;
                    end
                    //say(itoa(info_prota.id_prota.x)+" "+itoa(x));
                end
            end
            frame;
        end
    end
    case 6:
        loop
            if (exists(info_prota.id_prota))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=2;
                    info_prota.dano_exp=2;
                    
                    if (info_prota.id_prota.x>x) info_prota.dano_vel_horiz=30;
                    else info_prota.dano_vel_horiz=-30;
                    end
                end
            end
            temp=collision(type normal_shot);
            while (temp)
                temp.energia=0;
                temp=collision(type normal_shot);
            end
            frame;
        end
    end
    case 7,8:
        loop
            temp=collision(type normal_shot);
            while (temp)
                temp.energia=0;
                temp=collision(type normal_shot);
            end
            frame;
        end
    end
    default:
        signal(id,s_freeze);
        frame;
    end
    end //switch
end

process dragon_fire (file,graph,x,y,angle, int df_vel)
begin
    //say(itoa(x)+" "+itoa(y));
    resolution=10;
    z=8;
    while ((x>-100) && (y<2500))
        advance(df_vel);
        
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=2;
                info_prota.dano_exp=2;
                
                if (info_prota.id_prota.x>(x/10)) info_prota.dano_vel_horiz=30;
                else info_prota.dano_vel_horiz=-30;
                end
            end
        end
        
        frame;
    end
end

process dragon_laser (file,graph,x,y,angle)
begin
    resolution=10;
    z=8;
    flags=16;
    size_y=200;
    while (alpha>0)
        alpha-=6;
        
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=7;
                info_prota.dano_exp=4;
                
                if (info_prota.id_prota.x>(x/10)) info_prota.dano_vel_horiz=40;
                else info_prota.dano_vel_horiz=-40;
                end
            end
        end
        
        frame;
    end
end

process dragon_homing (file,graph,x,y, int angle2)
private
    cont;
begin
    resolution=10;
    z=8;
    loop
        angle+=20000;
        if (exists(info_prota.id_prota))
            angle2=near_angle(angle2,fget_angle(x,y,info_prota.id_prota.x*10,info_prota.id_prota.y*10),2000);
            xadvance(angle2,10);
            
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=3;
                info_prota.dano_exp=3;
                
                if (info_prota.id_prota.x>(x/10)) info_prota.dano_vel_horiz=20;
                else info_prota.dano_vel_horiz=-20;
                end
            end
        end
        
        xadvance(angle2,10);
        cont++;
        if (cont>250) alpha-=5; end
        if (alpha<=0) break; end
        
        frame;
    end
end

process ladrillo_cae(int lc_tilex, int lc_tiley)
private
    int temblor;
begin
    file=id_tscroll.ts_file;
    graph=obtener_tile(&nivel,lc_tilex,lc_tiley,0);
    x2=(lc_tilex*id_tscroll.tmapa[0].ancho_tile)+(id_tscroll.tmapa[0].ancho_tile/2);
    y2=(lc_tiley*id_tscroll.tmapa[0].alto_tile)+(id_tscroll.tmapa[0].alto_tile/2);
    z=-2;
    
    modificar_tile(&nivel,lc_tilex,lc_tiley,0,0);
    ts_actualiza_tiles(&id_tscroll);
    tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
    
    temblor=enem_temblor2(id,4);
    while (y2<512)
        if (!exists(temblor))
            energia++;
            if (energia>5) energia=5; end
            y2+=energia;
            modificar_tile(&durezas,lc_tilex,lc_tiley,0,0);
        end
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
end

process dragon_body (file,graph,x2,y2,z)
private
    int dragon_id[9];
    int x_orig,y_orig;
    
    int enem_estado;        //0: cabeceando
                            //1: cambio de color
                            //2: abre boca para disparo
                            //3: disparo bsico (3 bolas / homing)
                            //4: disparo fuerte (lluvia de fuego / megarrayo)
                            //5: comer
                            //6: dolor
    int enem_estado2;
    int cont_estado;
    
    int temp_x,temp_y;
    int temp_x2,temp_y2;
    int temp_disp1,temp_disp2;
    int temp_angle;
    int temp_espada;
    int cont1;
    int cont2;
begin
    //x_orig=3680-320;
    //y_orig=176-240;
    x_orig=x2-68;
    y_orig=y2-68;
    dragon_id[0]=dragon_part(file,2,x2,y2-190,1);   //cabeza
    dragon_id[1]=dragon_part(file,4,x2,y2-190,2);   //boca
    dragon_id[2]=dragon_part(file,7,x2,y2-190,3);   //cabeza dur
    dragon_id[3]=dragon_part(file,8,x2,y2-190,4);   //boca dur
    dragon_id[4]=dragon_part(file,5,x2,y2-190,5);   //cuello
    dragon_id[5]=dragon_part(file,5,x2,y2-190,6);   //cuello
    dragon_id[6]=dragon_part(file,5,x2,y2-190,7);   //cuello
    dragon_id[7]=dragon_part(file,5,x2,y2-190,8);   //cuello
    //dragon_id[8]=dragon_part(file,5,x2,y2-190,8);   //cuello
    dragon_id[9]=dragon_part(file,6,x2,y2-190,1);   //brazo
    dragon_id[9].angle=-90000;
    
    //write_int(0,320,0,2,&dragon_id[0].energia);
    
    cont1=0;
    while (cont1<68)
        cont1++;
        x2--;
        y2--;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        
        get_real_point(1,&temp_x,&temp_y);
        dragon_id[0].x=x-cont1;
        dragon_id[0].y=temp_y-70;
        dragon_id[0].angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                      dragon_id[0].x,dragon_id[0].y)+180000;
        dragon_id[1].x=x-cont1;
        dragon_id[1].y=temp_y-70;
        dragon_id[1].angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                      dragon_id[0].x,dragon_id[0].y)+180000;
        dragon_id[2].x=x-cont1;
        dragon_id[2].y=temp_y-70;
        dragon_id[2].angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                      dragon_id[0].x,dragon_id[0].y)+180000;
        dragon_id[3].x=x-cont1;
        dragon_id[3].y=temp_y-70;
        dragon_id[3].angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                      dragon_id[0].x,dragon_id[0].y)+180000;
                                      
        temp_x2=temp_x-dragon_id[0].x;
        temp_y2=temp_y-dragon_id[0].y;
        for (cont2=0;cont2<4;cont2++)
            dragon_id[4+cont2].x=temp_x-((temp_x2*cont2)/4);
            dragon_id[4+cont2].y=temp_y-((temp_y2*cont2)/4);
        end
        
        get_real_point(2,&temp_x,&temp_y);
        dragon_id[9].x=temp_x;
        dragon_id[9].y=temp_y;
        dragon_id[9].angle=near_angle(dragon_id[9].angle,180000,1500);
        
        frame;
    end
    
    cont1=0;
    prota_control=true;
    while (cont1<200)
        dragon_id[0].angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                      dragon_id[0].x,dragon_id[0].y)+180000;
        dragon_id[1].angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                      dragon_id[1].x,dragon_id[1].y)+180000;
        dragon_id[2].angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                      dragon_id[2].x,dragon_id[2].y)+180000;
        dragon_id[3].angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                      dragon_id[3].x,dragon_id[3].y)+180000;
        
        cont1++;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    energia=400;
    enem_ener_interface(id);
    get_real_point(1,&temp_x2,&temp_y2);
    temp_x2*=10;
    temp_y2*=10;
    //x_orig*=10;
    //y_orig*=10;
    for (cont2=0;cont2<8;cont2++)
        dragon_id[cont2].resolution=10;
        dragon_id[cont2].x*=10;
        dragon_id[cont2].y*=10;
    end
    
    while (energia>0)
        switch (enem_estado)
        case 0:                     //cabeceando
            if (cont_estado==0)
                temp_x=rand(1600,3000);
                temp_y=rand(600,1100);
                cont_estado=200;
            end
            dragon_id[0].x+=(temp_x-dragon_id[0].x)/50;
            dragon_id[0].y+=(temp_y-dragon_id[0].y)/50;
            dragon_id[1].x+=(temp_x-dragon_id[1].x)/50;
            dragon_id[1].y+=(temp_y-dragon_id[1].y)/50;
            dragon_id[2].x+=(temp_x-dragon_id[2].x)/50;
            dragon_id[2].y+=(temp_y-dragon_id[2].y)/50;
            dragon_id[3].x+=(temp_x-dragon_id[3].x)/50;
            dragon_id[3].y+=(temp_y-dragon_id[3].y)/50;
            if ( (abs(temp_x-dragon_id[0].x)<50) && (abs(temp_y-dragon_id[0].y)<50) )
                temp_x=rand(1600,3000);
                temp_y=rand(600,1100);
            end
            
            dragon_id[0].angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                          dragon_id[0].x/10,dragon_id[0].y/10)+180000;
            dragon_id[1].angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                          dragon_id[1].x/10,dragon_id[1].y/10)+180000;
            dragon_id[2].angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                          dragon_id[2].x/10,dragon_id[2].y/10)+180000;
            dragon_id[3].angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                          dragon_id[3].x/10,dragon_id[3].y/10)+180000;
                                          
            //temp_x2=temp_x-dragon_id[0].x;
            //temp_y2=temp_y-dragon_id[0].y;
            for (cont2=0;cont2<4;cont2++)
                dragon_id[4+cont2].x=temp_x2+(((dragon_id[0].x-temp_x2)*cont2)/4);
                dragon_id[4+cont2].y=temp_y2+(((dragon_id[0].y-temp_y2)*cont2)/4);
                //dragon_id[4+cont2].x=temp_x-((temp_x2*cont2)/3);
                //dragon_id[4+cont2].y=temp_y-((temp_y2*cont2)/3);
            end
            
            cont_estado--;
            if (cont_estado==1)
                cont_estado=0;
                enem_estado=rand(2,5);
                enem_estado2=0;
            end
        end
        case 1:                 //cambiando color
            switch (enem_estado2)
            case 0:
                cont_estado=rand(180,221);
                enem_estado2=1;
                cont1=0;
            end
            case 1:
                cont1++;
                dragon_id[0].graph=(cont1&1)+2;
                temp_angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                      dragon_id[0].x/10,dragon_id[0].y/10)+180000;
                
                dragon_id[0].angle=near_angle(dragon_id[0].angle,temp_angle,2000);
                dragon_id[1].angle=near_angle(dragon_id[1].angle,temp_angle,2000);
                dragon_id[2].angle=near_angle(dragon_id[2].angle,temp_angle,2000);
                dragon_id[3].angle=near_angle(dragon_id[3].angle,temp_angle,2000);
                if (cont1==cont_estado)
                    cont1=0;
                    cont_estado=0;
                    enem_estado=0;
                    enem_estado2=0;
                end
            end
            end //switch
        end
        case 2:                 //ataque cargado
            switch (enem_estado2)
            case 0:             //posicionando
                temp_x=2100;
                if (exists(info_prota.id_prota)) temp_y=(info_prota.id_prota.y-8)*10; end
                
                dragon_id[0].x+=(temp_x-dragon_id[0].x)/50;
                dragon_id[0].y+=(temp_y-dragon_id[0].y)/50;
                dragon_id[1].x+=(temp_x-dragon_id[1].x)/50;
                dragon_id[1].y+=(temp_y-dragon_id[1].y)/50;
                dragon_id[2].x+=(temp_x-dragon_id[2].x)/50;
                dragon_id[2].y+=(temp_y-dragon_id[2].y)/50;
                dragon_id[3].x+=(temp_x-dragon_id[3].x)/50;
                dragon_id[3].y+=(temp_y-dragon_id[3].y)/50;
                
                dragon_id[0].angle=near_angle(dragon_id[0].angle,135000,1000);
                dragon_id[1].angle=near_angle(dragon_id[1].angle,225000,1000);
                dragon_id[2].angle=near_angle(dragon_id[2].angle,135000,1000);
                dragon_id[3].angle=near_angle(dragon_id[3].angle,225000,1000);
                
                for (cont2=0;cont2<4;cont2++)
                    dragon_id[4+cont2].x=temp_x2+(((dragon_id[0].x-temp_x2)*cont2)/4);
                    dragon_id[4+cont2].y=temp_y2+(((dragon_id[0].y-temp_y2)*cont2)/4);
                end
                
                if ( (abs(temp_x-dragon_id[0].x)<50) && (abs(temp_y-dragon_id[0].y)<50) && 
                     (dragon_id[0].angle==135000) )
                    enem_estado2=1;
                end
                
                cont1=get_id(type normal_shot);
                while (cont1)
                    if ( (abs((cont1.x*10) - (dragon_id[0].x-60)) < 60) &&
                         (abs((cont1.y*10) - (dragon_id[0].y)) < 60)    )
                        dragon_id[0].energia-=cont1.energia;
                        cont1.energia=0;
                        if (dragon_id[0].mi_temblor!=0 && exists(dragon_id[0].mi_temblor))
                            dragon_id[0].mi_temblor.energia=3;
                            dragon_id[1].mi_temblor.energia=3;
                            dragon_id[2].mi_temblor.energia=3;
                            dragon_id[3].mi_temblor.energia=3;
                        else
                            dragon_id[0].mi_temblor=enem_xtemblor(dragon_id[0],3,10);
                            dragon_id[1].mi_temblor=enem_xtemblor(dragon_id[1],3,10);
                            dragon_id[2].mi_temblor=enem_xtemblor(dragon_id[2],3,10);
                            dragon_id[3].mi_temblor=enem_xtemblor(dragon_id[3],3,10);
                        end
                    end
                    cont1=get_id(type normal_shot);
                end
                if (dragon_id[0].energia<=0)
                    enem_estado=6;
                    enem_estado2=0;
                    cont_estado=0;
                    dragon_id[0].energia=30;
                end
            end
            case 1:         //persiguiendo
                if (exists(info_prota.id_prota))
                    dragon_id[0].y=(info_prota.id_prota.y-8)*10;
                    dragon_id[1].y=(info_prota.id_prota.y-8)*10;
                    dragon_id[2].y=(info_prota.id_prota.y-8)*10;
                    dragon_id[3].y=(info_prota.id_prota.y-8)*10;
                end
                for (cont2=0;cont2<4;cont2++)
                    dragon_id[4+cont2].x=temp_x2+(((dragon_id[0].x-temp_x2)*cont2)/4);
                    dragon_id[4+cont2].y=temp_y2+(((dragon_id[0].y-temp_y2)*cont2)/4);
                end
                
                cont_estado++;
                if (cont_estado==50)
                    cont_estado=0;
                    enem_estado2=2;
                end
                
                cont1=get_id(type normal_shot);
                while (cont1)
                    if ( (abs((cont1.x*10) - (dragon_id[0].x-60)) < 60) &&
                         (abs((cont1.y*10) - (dragon_id[0].y)) < 60)    )
                        dragon_id[0].energia-=cont1.energia;
                        cont1.energia=0;
                        if (dragon_id[0].mi_temblor!=0 && exists(dragon_id[0].mi_temblor))
                            dragon_id[0].mi_temblor.energia=3;
                            dragon_id[1].mi_temblor.energia=3;
                            dragon_id[2].mi_temblor.energia=3;
                            dragon_id[3].mi_temblor.energia=3;
                        else
                            dragon_id[0].mi_temblor=enem_xtemblor(dragon_id[0],3,10);
                            dragon_id[1].mi_temblor=enem_xtemblor(dragon_id[1],3,10);
                            dragon_id[2].mi_temblor=enem_xtemblor(dragon_id[2],3,10);
                            dragon_id[3].mi_temblor=enem_xtemblor(dragon_id[3],3,10);
                        end
                    end
                    cont1=get_id(type normal_shot);
                end
                if (dragon_id[0].energia<=0)
                    enem_estado=6;
                    enem_estado2=0;
                    cont_estado=0;
                    dragon_id[0].energia=30;
                end
            end
            case 2:         //disparando
                cont_estado++;
                switch (cont_estado)
                case 50:
                    if (dragon_id[0].graph==2)
                        dragon_fire (file,9,dragon_id[0].x,dragon_id[0].y,dragon_id[0].angle+45000,60);
                    else
                        dragon_laser(file,10,dragon_id[0].x,dragon_id[0].y,dragon_id[0].angle+45000);
                    end
                end
                case 100,150,200:
                    if (dragon_id[0].graph==2)
                        dragon_fire (file,9,dragon_id[0].x,dragon_id[0].y,dragon_id[0].angle+45000,60);
                    end
                end
                case 300:
                    enem_estado2=3;
                    cont_estado=0;
                end
                end //switch
                
                cont1=get_id(type normal_shot);
                while (cont1)
                    if ( (abs((cont1.x*10) - (dragon_id[0].x-60)) < 60) &&
                         (abs((cont1.y*10) - (dragon_id[0].y)) < 60)    )
                        dragon_id[0].energia-=cont1.energia;
                        cont1.energia=0;
                        if (dragon_id[0].mi_temblor!=0 && exists(dragon_id[0].mi_temblor))
                            dragon_id[0].mi_temblor.energia=3;
                            dragon_id[1].mi_temblor.energia=3;
                            dragon_id[2].mi_temblor.energia=3;
                            dragon_id[3].mi_temblor.energia=3;
                        else
                            dragon_id[0].mi_temblor=enem_xtemblor(dragon_id[0],3,10);
                            dragon_id[1].mi_temblor=enem_xtemblor(dragon_id[1],3,10);
                            dragon_id[2].mi_temblor=enem_xtemblor(dragon_id[2],3,10);
                            dragon_id[3].mi_temblor=enem_xtemblor(dragon_id[3],3,10);
                        end
                    end
                    cont1=get_id(type normal_shot);
                end
                if (dragon_id[0].energia<=0)
                    enem_estado=6;
                    enem_estado2=0;
                    cont_estado=0;
                    dragon_id[0].energia=30;
                end
            end
            case 3:         //cerrando la boca
                dragon_id[0].angle=near_angle(dragon_id[0].angle,180000,1000);
                dragon_id[1].angle=near_angle(dragon_id[1].angle,180000,1000);
                dragon_id[2].angle=near_angle(dragon_id[2].angle,180000,1000);
                dragon_id[3].angle=near_angle(dragon_id[3].angle,180000,1000);
                if (dragon_id[0].angle==180000)
                    enem_estado=rand(0,1);
                    enem_estado2=0;
                    cont_estado=0;
                end
                
                cont1=get_id(type normal_shot);
                while (cont1)
                    if ( (abs((cont1.x*10) - (dragon_id[0].x-40)) < 40) &&
                         (abs((cont1.y*10) - (dragon_id[0].y)) < 40)    )
                        dragon_id[0].energia-=cont1.energia;
                        cont1.energia=0;
                        if (dragon_id[0].mi_temblor!=0 && exists(dragon_id[0].mi_temblor))
                            dragon_id[0].mi_temblor.energia=3;
                            dragon_id[1].mi_temblor.energia=3;
                            dragon_id[2].mi_temblor.energia=3;
                            dragon_id[3].mi_temblor.energia=3;
                        else
                            dragon_id[0].mi_temblor=enem_xtemblor(dragon_id[0],3,10);
                            dragon_id[1].mi_temblor=enem_xtemblor(dragon_id[1],3,10);
                            dragon_id[2].mi_temblor=enem_xtemblor(dragon_id[2],3,10);
                            dragon_id[3].mi_temblor=enem_xtemblor(dragon_id[3],3,10);
                        end
                    end
                    cont1=get_id(type normal_shot);
                end
                if (dragon_id[0].energia<=0)
                    enem_estado=6;
                    enem_estado2=0;
                    cont_estado=0;
                    dragon_id[0].energia=30;
                end
            end
            
            end //switch
        end
        case 3:
            switch (cont_estado)
            case 0:
                temp_angle=0;
            end
            case 1..50:
                if (temp_angle<45000) temp_angle+=1000; end
            end
            case 75:
                if (dragon_id[0].graph==3) enem_estado2=1; end
            end
            case 100:
                if (dragon_id[0].graph==2)
                    dragon_fire (file,9,dragon_id[0].x,dragon_id[0].y,dragon_id[0].angle+45000,60);
                else
                    //dragon_laser(file,10,dragon_id[0].x,dragon_id[0].y,dragon_id[0].angle+45000);
                    dragon_homing(file,11,dragon_id[0].x,dragon_id[0].y,dragon_id[0].angle+45000);
                end
                enem_estado2=0;
            end
            case 150,200,250:
                if (dragon_id[0].graph==2)
                    dragon_fire (file,9,dragon_id[0].x,dragon_id[0].y,dragon_id[0].angle+45000,60);
                end
            end
            case 251..300:
                if (temp_angle>0) temp_angle-=1000; end
            end
            case 301:
                enem_estado=rand(0,1);
                enem_estado2=0;
                cont_estado=0;
            end
            end //switch
            cont_estado++;
            
            if (enem_estado2==0)
                dragon_id[0].angle=near_angle(dragon_id[0].angle,
                                              fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                              dragon_id[0].x/10,dragon_id[0].y/10)
                                              +180000-temp_angle,1000);
                dragon_id[1].angle=near_angle(dragon_id[1].angle,
                                              fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                              dragon_id[1].x/10,dragon_id[1].y/10)
                                              +180000+temp_angle,1000);
                dragon_id[2].angle=near_angle(dragon_id[2].angle,
                                              fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                              dragon_id[2].x/10,dragon_id[2].y/10)
                                              +180000-temp_angle,1000);
                dragon_id[3].angle=near_angle(dragon_id[3].angle,
                                              fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                              dragon_id[3].x/10,dragon_id[3].y/10)
                                              +180000+temp_angle,1000);
            end
            
            /*cont1=get_id(type dragon_fire);
            if (cont1) signal(cont1,s_kill); end
            dragon_fire (file,9,dragon_id[0].x+(80*cos(dragon_id[0].angle-temp_angle)),
                                dragon_id[0].y+(80*sin(dragon_id[0].angle-temp_angle)),
                         dragon_id[0].angle+45000,0);*/
            //choque con disparos
            cont1=get_id(type normal_shot);
            while (cont1)
                if ( (abs((cont1.x*10) - (dragon_id[0].x+(80*cos(dragon_id[0].angle-temp_angle)))) < 80) &&
                     (abs((cont1.y*10) - (dragon_id[0].y+(80*sin(dragon_id[0].angle-temp_angle)))) < 80)    )
                    dragon_id[0].energia-=cont1.energia;
                    cont1.energia=0;
                    if (dragon_id[0].mi_temblor!=0 && exists(dragon_id[0].mi_temblor))
                        dragon_id[0].mi_temblor.energia=3;
                        dragon_id[1].mi_temblor.energia=3;
                        dragon_id[2].mi_temblor.energia=3;
                        dragon_id[3].mi_temblor.energia=3;
                    else
                        dragon_id[0].mi_temblor=enem_xtemblor(dragon_id[0],3,10);
                        dragon_id[1].mi_temblor=enem_xtemblor(dragon_id[1],3,10);
                        dragon_id[2].mi_temblor=enem_xtemblor(dragon_id[2],3,10);
                        dragon_id[3].mi_temblor=enem_xtemblor(dragon_id[3],3,10);
                    end
                end
                cont1=get_id(type normal_shot);
            end
            if (dragon_id[0].energia<=0)
                enem_estado=6;
                enem_estado2=0;
                cont_estado=0;
                dragon_id[0].energia=30;
            end
        end
        case 4:
            if (dragon_id[0].graph==2)
                switch (cont_estado)
                case 0..70:
                    temp_x=3100;
                    temp_y=650;
                    temp_angle=135000;
                    dragon_id[9].angle=near_angle(dragon_id[9].angle,45000,1000);
                    
                    if (dragon_id[0].angle > temp_angle-15000) dragon_id[0].angle-=2000; end
                    if (dragon_id[1].angle > temp_angle+15000) dragon_id[1].angle-=2000; end
                    if (dragon_id[2].angle > temp_angle-15000) dragon_id[2].angle-=2000; end
                    if (dragon_id[3].angle > temp_angle+15000) dragon_id[3].angle-=2000; end
                end
                case 100:
                    dragon_fire (file,9,dragon_id[0].x,dragon_id[0].y,dragon_id[0].angle+15000,60);
                end
                case 150,175,200,225,250,275,300,325,350:
                    dragon_fire (file,9,(160*rand(0,14))+80,-100,-90000,40);
                end
                case 400:
                    enem_estado=rand(0,1);
                    enem_estado2=0;
                    cont_estado=0;
                end
                end //switch
            
                if (cont_estado>100)
                    temp_x=2520;
                    temp_y=600;
                    temp_angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                          dragon_id[0].x/10,dragon_id[0].y/10)+180000;
                    dragon_id[9].angle=near_angle(dragon_id[9].angle,180000,1000);
                    
                    dragon_id[0].angle=near_angle(dragon_id[0].angle,temp_angle,2000);
                    dragon_id[1].angle=near_angle(dragon_id[1].angle,temp_angle,2000);
                    dragon_id[2].angle=near_angle(dragon_id[2].angle,temp_angle,2000);
                    dragon_id[3].angle=near_angle(dragon_id[3].angle,temp_angle,2000);
                end
                
            else
                switch (cont_estado)
                case 0:         temp_angle=0; end
                case 1..50:     if (temp_angle<45000) temp_angle+=1000; end     end
                case 75:        enem_estado2=1; end
                case 100:
                    dragon_laser(file,10,dragon_id[0].x,dragon_id[0].y,dragon_id[0].angle+45000);
                    enem_estado2=0;
                end
                case 251..300:
                    if (temp_angle>0) temp_angle-=1000; end
                end
                case 301:
                    enem_estado=rand(0,1);
                    enem_estado2=0;
                    cont_estado=0;
                end
                end //switch
                
                if (enem_estado2==0)
                    dragon_id[0].angle=near_angle(dragon_id[0].angle,
                                                  fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                                  dragon_id[0].x/10,dragon_id[0].y/10)
                                                  +180000-temp_angle,1000);
                    dragon_id[1].angle=near_angle(dragon_id[1].angle,
                                                  fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                                  dragon_id[1].x/10,dragon_id[1].y/10)
                                                  +180000+temp_angle,1000);
                    dragon_id[2].angle=near_angle(dragon_id[2].angle,
                                                  fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                                  dragon_id[2].x/10,dragon_id[2].y/10)
                                                  +180000-temp_angle,1000);
                    dragon_id[3].angle=near_angle(dragon_id[3].angle,
                                                  fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                                  dragon_id[3].x/10,dragon_id[3].y/10)
                                                  +180000+temp_angle,1000);
                end
                
                //choque con disparos
                cont1=get_id(type normal_shot);
                while (cont1)
                    if ( (abs((cont1.x*10) - (dragon_id[0].x+(80*cos(dragon_id[0].angle-temp_angle)))) < 80) &&
                         (abs((cont1.y*10) - (dragon_id[0].y+(80*sin(dragon_id[0].angle-temp_angle)))) < 80)    )
                        dragon_id[0].energia-=cont1.energia;
                        cont1.energia=0;
                        if (dragon_id[0].mi_temblor!=0 && exists(dragon_id[0].mi_temblor))
                            dragon_id[0].mi_temblor.energia=3;
                            dragon_id[1].mi_temblor.energia=3;
                            dragon_id[2].mi_temblor.energia=3;
                            dragon_id[3].mi_temblor.energia=3;
                        else
                            dragon_id[0].mi_temblor=enem_xtemblor(dragon_id[0],3,10);
                            dragon_id[1].mi_temblor=enem_xtemblor(dragon_id[1],3,10);
                            dragon_id[2].mi_temblor=enem_xtemblor(dragon_id[2],3,10);
                            dragon_id[3].mi_temblor=enem_xtemblor(dragon_id[3],3,10);
                        end
                    end
                    cont1=get_id(type normal_shot);
                end
                if (dragon_id[0].energia<=0)
                    enem_estado=6;
                    enem_estado2=0;
                    cont_estado=0;
                    dragon_id[0].energia=30;
                end
            end
            cont_estado++;
        end
        
        case 5:
            switch (enem_estado2)
            case 0:             //posicionando
                temp_x=2100;
                if (exists(info_prota.id_prota)) temp_y=(info_prota.id_prota.y-8)*10; end
                
                dragon_id[0].x+=(temp_x-dragon_id[0].x)/50;
                dragon_id[0].y+=(temp_y-dragon_id[0].y)/50;
                dragon_id[1].x+=(temp_x-dragon_id[1].x)/50;
                dragon_id[1].y+=(temp_y-dragon_id[1].y)/50;
                dragon_id[2].x+=(temp_x-dragon_id[2].x)/50;
                dragon_id[2].y+=(temp_y-dragon_id[2].y)/50;
                dragon_id[3].x+=(temp_x-dragon_id[3].x)/50;
                dragon_id[3].y+=(temp_y-dragon_id[3].y)/50;
                
                dragon_id[0].angle=near_angle(dragon_id[0].angle,135000,1000);
                dragon_id[1].angle=near_angle(dragon_id[1].angle,225000,1000);
                dragon_id[2].angle=near_angle(dragon_id[2].angle,135000,1000);
                dragon_id[3].angle=near_angle(dragon_id[3].angle,225000,1000);
                
                for (cont2=0;cont2<4;cont2++)
                    dragon_id[4+cont2].x=temp_x2+(((dragon_id[0].x-temp_x2)*cont2)/4);
                    dragon_id[4+cont2].y=temp_y2+(((dragon_id[0].y-temp_y2)*cont2)/4);
                end
                
                if ( (abs(temp_x-dragon_id[0].x)<50) && (abs(temp_y-dragon_id[0].y)<50) && 
                     (dragon_id[0].angle==135000) )
                    enem_estado2=1;
                end
                
                cont1=get_id(type normal_shot);
                while (cont1)
                    if ( (abs((cont1.x*10) - (dragon_id[0].x-60)) < 60) &&
                         (abs((cont1.y*10) - (dragon_id[0].y)) < 60)    )
                        dragon_id[0].energia-=cont1.energia;
                        cont1.energia=0;
                        if (dragon_id[0].mi_temblor!=0 && exists(dragon_id[0].mi_temblor))
                            dragon_id[0].mi_temblor.energia=3;
                            dragon_id[1].mi_temblor.energia=3;
                            dragon_id[2].mi_temblor.energia=3;
                            dragon_id[3].mi_temblor.energia=3;
                        else
                            dragon_id[0].mi_temblor=enem_xtemblor(dragon_id[0],3,10);
                            dragon_id[1].mi_temblor=enem_xtemblor(dragon_id[1],3,10);
                            dragon_id[2].mi_temblor=enem_xtemblor(dragon_id[2],3,10);
                            dragon_id[3].mi_temblor=enem_xtemblor(dragon_id[3],3,10);
                        end
                    end
                    cont1=get_id(type normal_shot);
                end
                if (dragon_id[0].energia<=0)
                    enem_estado=6;
                    enem_estado2=0;
                    cont_estado=0;
                    dragon_id[0].energia=30;
                end
            end
            case 1:         //persiguiendo
                if (exists(info_prota.id_prota))
                    dragon_id[0].y=(info_prota.id_prota.y-8)*10;
                    dragon_id[1].y=(info_prota.id_prota.y-8)*10;
                    dragon_id[2].y=(info_prota.id_prota.y-8)*10;
                    dragon_id[3].y=(info_prota.id_prota.y-8)*10;
                end
                for (cont2=0;cont2<4;cont2++)
                    dragon_id[4+cont2].x=temp_x2+(((dragon_id[0].x-temp_x2)*cont2)/4);
                    dragon_id[4+cont2].y=temp_y2+(((dragon_id[0].y-temp_y2)*cont2)/4);
                end
                
                cont_estado++;
                if (cont_estado==50)
                    cont_estado=0;
                    enem_estado2=2;
                end
                
                cont1=get_id(type normal_shot);
                while (cont1)
                    if ( (abs((cont1.x*10) - (dragon_id[0].x-60)) < 60) &&
                         (abs((cont1.y*10) - (dragon_id[0].y)) < 60)    )
                        dragon_id[0].energia-=cont1.energia;
                        cont1.energia=0;
                        if (dragon_id[0].mi_temblor!=0 && exists(dragon_id[0].mi_temblor))
                            dragon_id[0].mi_temblor.energia=3;
                            dragon_id[1].mi_temblor.energia=3;
                            dragon_id[2].mi_temblor.energia=3;
                            dragon_id[3].mi_temblor.energia=3;
                        else
                            dragon_id[0].mi_temblor=enem_xtemblor(dragon_id[0],3,10);
                            dragon_id[1].mi_temblor=enem_xtemblor(dragon_id[1],3,10);
                            dragon_id[2].mi_temblor=enem_xtemblor(dragon_id[2],3,10);
                            dragon_id[3].mi_temblor=enem_xtemblor(dragon_id[3],3,10);
                        end
                    end
                    cont1=get_id(type normal_shot);
                end
                if (dragon_id[0].energia<=0)
                    enem_estado=6;
                    enem_estado2=0;
                    cont_estado=0;
                    dragon_id[0].energia=30;
                end
            end
            case 2:         //comiendo
                temp_x=700;
                if (exists(info_prota.id_prota)) temp_y=(info_prota.id_prota.y-8)*10; end
                
                dragon_id[0].x+=(temp_x-dragon_id[0].x)/20;
                dragon_id[0].y+=(temp_y-dragon_id[0].y)/50;
                dragon_id[1].x+=(temp_x-dragon_id[1].x)/20;
                dragon_id[1].y+=(temp_y-dragon_id[1].y)/50;
                dragon_id[2].x+=(temp_x-dragon_id[2].x)/20;
                dragon_id[2].y+=(temp_y-dragon_id[2].y)/50;
                dragon_id[3].x+=(temp_x-dragon_id[3].x)/20;
                dragon_id[3].y+=(temp_y-dragon_id[3].y)/50;
                
                for (cont2=0;cont2<4;cont2++)
                    dragon_id[4+cont2].x=temp_x2+(((dragon_id[0].x-temp_x2)*cont2)/4);
                    dragon_id[4+cont2].y=temp_y2+(((dragon_id[0].y-temp_y2)*cont2)/4);
                end
                
                if ((dragon_id[0].x-temp_x) < 50) cont_estado=0; enem_estado2=3; end
                
                cont1=get_id(type normal_shot);
                while (cont1)
                    if ( (abs((cont1.x*10) - (dragon_id[0].x-60)) < 60) &&
                         (abs((cont1.y*10) - (dragon_id[0].y)) < 60)    )
                        dragon_id[0].energia-=cont1.energia;
                        cont1.energia=0;
                        if (dragon_id[0].mi_temblor!=0 && exists(dragon_id[0].mi_temblor))
                            dragon_id[0].mi_temblor.energia=3;
                            dragon_id[1].mi_temblor.energia=3;
                            dragon_id[2].mi_temblor.energia=3;
                            dragon_id[3].mi_temblor.energia=3;
                        else
                            dragon_id[0].mi_temblor=enem_xtemblor(dragon_id[0],3,10);
                            dragon_id[1].mi_temblor=enem_xtemblor(dragon_id[1],3,10);
                            dragon_id[2].mi_temblor=enem_xtemblor(dragon_id[2],3,10);
                            dragon_id[3].mi_temblor=enem_xtemblor(dragon_id[3],3,10);
                        end
                    end
                    cont1=get_id(type normal_shot);
                end
                if (dragon_id[0].energia<=0)
                    enem_estado=6;
                    enem_estado2=0;
                    cont_estado=0;
                    dragon_id[0].energia=30;
                end
            end
            case 3:         //cerrando la boca
                dragon_id[0].angle=near_angle(dragon_id[0].angle,180000,1000);
                dragon_id[1].angle=near_angle(dragon_id[1].angle,180000,1000);
                dragon_id[2].angle=near_angle(dragon_id[2].angle,180000,1000);
                dragon_id[3].angle=near_angle(dragon_id[3].angle,180000,1000);
                if (dragon_id[0].angle==180000)
                    enem_estado=rand(0,1);
                    enem_estado2=0;
                    cont_estado=0;
                end
                
                cont1=get_id(type normal_shot);
                while (cont1)
                    if ( (abs((cont1.x*10) - (dragon_id[0].x-40)) < 40) &&
                         (abs((cont1.y*10) - (dragon_id[0].y)) < 40)    )
                        dragon_id[0].energia-=cont1.energia;
                        cont1.energia=0;
                        if (dragon_id[0].mi_temblor!=0 && exists(dragon_id[0].mi_temblor))
                            dragon_id[0].mi_temblor.energia=3;
                            dragon_id[1].mi_temblor.energia=3;
                            dragon_id[2].mi_temblor.energia=3;
                            dragon_id[3].mi_temblor.energia=3;
                        else
                            dragon_id[0].mi_temblor=enem_xtemblor(dragon_id[0],3,10);
                            dragon_id[1].mi_temblor=enem_xtemblor(dragon_id[1],3,10);
                            dragon_id[2].mi_temblor=enem_xtemblor(dragon_id[2],3,10);
                            dragon_id[3].mi_temblor=enem_xtemblor(dragon_id[3],3,10);
                        end
                    end
                    cont1=get_id(type normal_shot);
                end
                if (dragon_id[0].energia<=0)
                    enem_estado=6;
                    enem_estado2=0;
                    cont_estado=0;
                    dragon_id[0].energia=30;
                end
            end
            
            end //switch
        end
        
        case 6:
            if (cont_estado<70)
                temp_x=3100;
                temp_y=650;
                temp_angle=60000;
                dragon_id[9].angle=near_angle(dragon_id[9].angle,45000,1000);
                
                if (dragon_id[0].angle > temp_angle-45000) dragon_id[0].angle-=2000; end
                if (dragon_id[1].angle > temp_angle+45000) dragon_id[1].angle-=2000; end
                if (dragon_id[2].angle > temp_angle-45000) dragon_id[2].angle-=2000; end
                if (dragon_id[3].angle > temp_angle+45000) dragon_id[3].angle-=2000; end
                /*dragon_id[0].angle=near_angle(dragon_id[0].angle,temp_angle-45000,2000);
                dragon_id[1].angle=near_angle(dragon_id[1].angle,temp_angle+45000,2000);
                dragon_id[2].angle=near_angle(dragon_id[2].angle,temp_angle-45000,2000);
                dragon_id[3].angle=near_angle(dragon_id[3].angle,temp_angle+45000,2000);*/
            elsif (cont_estado>200)
                temp_x=2520;
                temp_y=600;
                temp_angle=fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                      dragon_id[0].x/10,dragon_id[0].y/10)+180000;
                dragon_id[9].angle=near_angle(dragon_id[9].angle,180000,1000);
                
                if (dragon_id[0].angle < temp_angle-45000) dragon_id[0].angle+=2000; end
                if (dragon_id[1].angle < temp_angle+45000) dragon_id[1].angle+=2000; end
                if (dragon_id[2].angle < temp_angle-45000) dragon_id[2].angle+=2000; end
                if (dragon_id[3].angle < temp_angle+45000) dragon_id[3].angle+=2000; end
                /*dragon_id[0].angle=near_angle(dragon_id[0].angle,temp_angle,2000);
                dragon_id[1].angle=near_angle(dragon_id[1].angle,temp_angle,2000);
                dragon_id[2].angle=near_angle(dragon_id[2].angle,temp_angle,2000);
                dragon_id[3].angle=near_angle(dragon_id[3].angle,temp_angle,2000);*/
            end
            cont_estado++;
            
            dragon_id[0].x+=(temp_x-dragon_id[0].x)/50;
            dragon_id[0].y+=(temp_y-dragon_id[0].y)/50;
            dragon_id[1].x+=(temp_x-dragon_id[1].x)/50;
            dragon_id[1].y+=(temp_y-dragon_id[1].y)/50;
            dragon_id[2].x+=(temp_x-dragon_id[2].x)/50;
            dragon_id[2].y+=(temp_y-dragon_id[2].y)/50;
            dragon_id[3].x+=(temp_x-dragon_id[3].x)/50;
            dragon_id[3].y+=(temp_y-dragon_id[3].y)/50;
            
            
            for (cont2=0;cont2<4;cont2++)
                dragon_id[4+cont2].x=temp_x2+(((dragon_id[0].x-temp_x2)*cont2)/4);
                dragon_id[4+cont2].y=temp_y2+(((dragon_id[0].y-temp_y2)*cont2)/4);
            end
            
            if (cont_estado==300)
                enem_estado=rand(0,1);
                enem_estado2=0;
                cont_estado=0;
                dragon_id[0].energia=30;
            end
        end
        end //switch
        
                //para colisiones, falla con el ngulo
                /*cont1=get_id(type normal_shot);
                while (cont1)
                    if ( (abs((cont1.x*10) - (dragon_id[0].x+(60*cos(dragon_id[0].angle)))) < 60) &&
                         (abs((cont1.y*10) - (dragon_id[0].y+(60*sin(dragon_id[0].angle)))) < 60) )
                        dragon_id[0].energia-=cont1.energia;
                        cont1.energia=0;
                        if (dragon_id[0].mi_temblor!=0 && exists(dragon_id[0].mi_temblor))
                            dragon_id[0].mi_temblor.energia=3;
                        else
                            dragon_id[0].mi_temblor=enem_xtemblor(dragon_id[0],3,10);
                        end
                    end
                    cont1=get_id(type normal_shot);
                end*/
        
        //movimiento del brazo
        if (enem_estado!=6)
            temp_disp1=0;
            temp_disp2=get_id(type normal_shot);
            while (temp_disp2)
                if (temp_disp1 && exists(temp_disp1) && (temp_disp1.energia>0))
                    if (temp_disp2.x>temp_disp1.x)
                        temp_disp1=temp_disp2;
                    end
                else
                    temp_disp1=temp_disp2;
                end
                temp_disp2=get_id(type normal_shot);
            end
            
            if (temp_disp1)
                dragon_id[9].angle=near_angle(dragon_id[9].angle,
                                   fget_angle(temp_disp1.x,temp_disp1.y,dragon_id[9].x,dragon_id[9].y)+180000,
                                             2000);
            else
                if (exists(info_prota.id_prota))
                    dragon_id[9].angle=near_angle(dragon_id[9].angle,
                                                 fget_angle(info_prota.id_prota.x,info_prota.id_prota.y,
                                                 dragon_id[9].x,dragon_id[9].y)+180000,
                                                 2000);
                end
            end
        else
            //impacto con las balas
            temp_disp1=collision(type normal_shot);
            while (temp_disp1)
                energia-=temp_disp1.energia;
                temp_disp1.energia=0;
                if (mi_temblor!=0 && exists(mi_temblor))
                    mi_temblor.energia=3;
                else
                    mi_temblor=enem_temblor2(id,3);
                end
                temp_disp1=collision(type normal_shot);
            end
            temp_disp1=collision(type espadazo);
            if (temp_disp1 && (temp_disp1!=temp_espada))
                energia-=temp_disp1.energia;
                if (mi_temblor!=0 && exists(mi_temblor))
                    mi_temblor.energia=3;
                else
                    mi_temblor=enem_temblor(id,3);
                end
                temp_espada=temp_disp1;
            end
            
            //evitar que se desplace el cuerpo de su posicin
            if (mi_temblor!=0 && !exists(mi_temblor))
                mi_temblor=0;
                x2=x_orig;
                y2=y_orig;
                tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
            end
        end
        
        frame;
    end
    
    fade(200,200,200,255);
    frame(300);
    fade(100,100,100,255);
    
    for (cont1=0;cont1<8;cont1++)
        signal(dragon_id[cont1],s_freeze);
    end
    signal(dragon_id[9],s_freeze);
    frame(5000);
    prota_control=false;
    cont_estado=0;
    while (cont_estado<390)
        if (mi_temblor!=0 && exists(mi_temblor))
            mi_temblor.energia=3;
            dragon_id[9].mi_temblor.energia=3;
        else
            mi_temblor=enem_temblor2(id,3);
            dragon_id[9].mi_temblor=enem_temblor2(dragon_id[9],3);
        end
        if (dragon_id[0].mi_temblor!=0 && exists(dragon_id[0].mi_temblor))
            dragon_id[0].mi_temblor.energia=3;
            dragon_id[1].mi_temblor.energia=3;
            dragon_id[2].mi_temblor.energia=3;
            dragon_id[3].mi_temblor.energia=3;
            dragon_id[4].mi_temblor.energia=3;
            dragon_id[5].mi_temblor.energia=3;
            dragon_id[6].mi_temblor.energia=3;
            dragon_id[7].mi_temblor.energia=3;
        else
            dragon_id[0].mi_temblor=enem_xtemblor(dragon_id[0],3,10);
            dragon_id[1].mi_temblor=enem_xtemblor(dragon_id[1],3,10);
            dragon_id[2].mi_temblor=enem_xtemblor(dragon_id[2],3,10);
            dragon_id[3].mi_temblor=enem_xtemblor(dragon_id[3],3,10);
            dragon_id[4].mi_temblor=enem_xtemblor(dragon_id[4],3,10);
            dragon_id[5].mi_temblor=enem_xtemblor(dragon_id[5],3,10);
            dragon_id[6].mi_temblor=enem_xtemblor(dragon_id[6],3,10);
            dragon_id[7].mi_temblor=enem_xtemblor(dragon_id[7],3,10);
        end
        
        if (cont_estado>150)
            y++;
            for (cont1=0;cont1<8;cont1++)
                dragon_id[cont1].y+=10;
            end
            dragon_id[9].y++;
        end
        
        cont_estado++;
        frame;
    end
    
    for (cont1=0;cont1<8;cont1++)
        signal(dragon_id[cont1],s_kill);
    end
    signal(dragon_id[9],s_kill);
    prota_control=true;
end


process fuego_espiritual (file,x2,y2)
private
    int cont_anim;
    int temp;
begin
    graph=9;
    while (graph!=11)
        cont_anim++;
        switch (cont_anim)
        case 5: graph=10; end
        case 10: graph=9; cont_anim=0; end
        end //switch
        
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=2;
                info_prota.dano_exp=4;
                if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                else info_prota.dano_vel_horiz=-20;
                end
            end
        end
        
        temp=collision(type normal_shot);
        while (temp)
            temp.energia=0;
            temp=collision(type normal_shot);
        end
        
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    if (exists(info_prota.id_prota))
        angle=fget_angle(x,y,info_prota.id_prota.x,info_prota.id_prota.y);
    end
    resolution=10;
    x*=10;
    y*=10;
    
    while (!out_region(id,0))
        advance(50);
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=2;
                info_prota.dano_exp=4;
                if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                else info_prota.dano_vel_horiz=-20;
                end
            end
        end
        
        temp=collision(type normal_shot);
        while (temp)
            temp.energia=0;
            temp=collision(type normal_shot);
        end
        
        frame;
    end
end


process fuego_espiritual2 (file,x2,y2)
private
    int cont_anim;
    int temp;
begin
    graph=9;
    while (graph!=12)
        cont_anim++;
        switch (cont_anim)
        case 5: graph=10; end
        case 10: graph=9; cont_anim=0; end
        end //switch
        
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=2;
                info_prota.dano_exp=4;
                if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                else info_prota.dano_vel_horiz=-20;
                end
            end
        end
        
        temp=collision(type normal_shot);
        while (temp)
            temp.energia=0;
            temp=collision(type normal_shot);
        end
        
        //tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    loop
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=2;
                info_prota.dano_exp=4;
                if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                else info_prota.dano_vel_horiz=-20;
                end
            end
        end
        
        temp=collision(type normal_shot);
        while (temp)
            temp.energia=0;
            temp=collision(type normal_shot);
        end
        
        frame;
    end
end

process fuego_boleadoras (x2,y2,fb_hijo1,fb_hijo2)
private
    int cont;
    int angle2;
begin
    tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
    for (cont=0;cont<=120;cont++)
        angle+=6000;
        if (angle>360000) angle-=360000; end
        fb_hijo1.x=x+ ((cont/12) * cos(angle));
        fb_hijo1.y=y+ ((cont/12) * sin(angle));
        fb_hijo2.x=x+ ((cont/12) * cos(angle+180000));
        fb_hijo2.y=y+ ((cont/12) * sin(angle+180000));
        
        if (cont==96)
            //signal(fb_hijo1,s_freeze);
            //signal(fb_hijo2,s_freeze);
            fb_hijo1.graph=12;
            fb_hijo2.graph=12;
        end
        if (cont>96)
            fb_hijo1.angle=-angle-90000;
            fb_hijo2.angle=-angle+90000;
        end
        frame;
    end
    for (cont=0;cont<(energia/5);cont++)
        angle+=6000;
        if (angle>360000) angle-=360000; end
        fb_hijo1.x=x+ (10 * cos(angle));
        fb_hijo1.y=y+ (10 * sin(angle));
        fb_hijo2.x=x+ (10 * cos(angle+180000));
        fb_hijo2.y=y+ (10 * sin(angle+180000));
        fb_hijo1.angle=-angle-90000;
        fb_hijo2.angle=-angle+90000;
        frame;
    end
    father.graph=3;
    cont=0;
    resolution=10;
    //tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
    x*=10;
    y*=10;
    if (father.flags==0) angle2=180000; end
    loop
        cont++;
        if (cont==25) father.graph=2; end
        if (exists(info_prota.id_prota))
            angle2=near_angle(angle2,fget_angle(x/10,y/10,info_prota.id_prota.x,info_prota.id_prota.y),2000);
        end
        xadvance(angle2,40);
        
        angle+=12000;
        if (angle>360000) angle-=360000; end
        fb_hijo1.x=(x/10) + (10 * cos(angle));
        fb_hijo1.y=(y/10) + (10 * sin(angle));
        fb_hijo2.x=(x/10) + (10 * cos(angle+180000));
        fb_hijo2.y=(y/10) + (10 * sin(angle+180000));
        fb_hijo1.angle=-angle-90000;
        fb_hijo2.angle=-angle+90000;
        
        if (cont>250)
            alpha-=3;
            fb_hijo1.alpha=alpha;
            fb_hijo2.alpha=alpha;
        end
        if (alpha<=0) break; end
        frame;
    end
    
    signal(fb_hijo1,s_kill);
    signal(fb_hijo2,s_kill);
end

process lanza_fuego (file,x,y,angle)
private
    int temp;
begin
    graph=11;
    resolution=10;
    x*=10;
    y*=10;
    while (!out_region(id,0))
        advance(60);
        
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=2;
                info_prota.dano_exp=4;
                if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                else info_prota.dano_vel_horiz=-20;
                end
            end
        end
        //impacto con balas
        temp=collision(type normal_shot);
        while (temp)
            temp.energia=0;
            temp=collision(type normal_shot);
        end
        
        frame;
    end
end

process satavamp_fuego (file,graph,x,y)
begin
    z=father.z+1;
    flags=4;
    signal(id,s_freeze);
    frame;
end

process satavamp_capa (file,graph,z)
begin
    signal(id,s_freeze);
    frame;
end


process satavamp ()
private
    int x3,y3;
    int angle2;             //sirve para flotar
    int angle3;
    int enem_estado;        //0: en espera
                            //1: teletransporte
                            //2: lanzamiento
                            //3: anillo de fuego
                            //4: boleadoras
                            //5: 3 bolas de fuego
    int enem_estado2;
    int cont_estado;
    
    int satavamp_capa_id;
    int satavamp_fuego_id;
    int hijos[5];
    
    int temp;               //usado en colision con las balas
    int cont;
    int temp_espada;
begin
    file=enem_grafs[0][cte_event];
    graph=1;
    z=1;
    x3=768;
    y3=-30;
    x2=x3;
    y2=y3;
    satavamp_capa_id=satavamp_capa(file,0,z+1);
    while (y3<48)
        y3++;
        y2=y3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    for (cont_estado=0;cont_estado<200;cont_estado++)
        angle2+=4000;
        y2=y3+(4*sin(angle2));
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    graph=2;
    satavamp_capa_id.x=x;
    satavamp_capa_id.y=y;
    satavamp_capa_id.graph=20;
    energia=500;
    enem_ener_interface(id);
    frame(10000);
    
    prota_control=true;
    angle2=0;
    
    loop
        switch (enem_estado)
        case 0:                     //espera
            graph=1;
            cont_estado++;
            angle2+=4000;
            y2=y3+(4*sin(angle2));
            if (cont_estado==400)
                cont_estado=0;
                angle2=0;
                y3=y2;
                enem_estado=rand(1,5);          //****************************************************
            end
        end
        case 1:                     //teletransporte
            switch (enem_estado2)
            case 0:         //desaparece
                graph=3;
                if (alpha>2) alpha-=3;
                else
                    alpha=0;
                    enem_estado2=1;
                    cont_estado=50*rand(0,energia/100);
                end
                angle2+=4000;
                y2=y3+(4*sin(angle2));
            end
            case 1:         //espera
                if (cont_estado>0) cont_estado--;
                else
                    enem_estado2=2;
                    x3=(rand(32,49)*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
                    y3=(rand(3,10)*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
                    x2=x3;
                    y2=y3;
                    graph=2;
                end
            end
            case 2:         //reaparece
                if (alpha<253) alpha+=3;
                else
                    alpha=255;
                    enem_estado2=3;
                    cont_estado=25+(energia/10);
                end
                angle2+=4000;
                y2=y3+(4*sin(angle2));
            end
            case 3:         //distraido
                if (cont_estado>0) cont_estado--;
                else
                    enem_estado2=0;
                    cont_estado=0;
                    enem_estado=rand(0,2);          //****************************************************
                end
            end
            end //switch
        end
        
        case 2:                 //lanzamiento
            switch (enem_estado2)
            case 0:         //saliendo de pantalla
                if (x3<656)//160)
                    x3--;
                    if (x3<480)
                        enem_estado2=1;
                        y3=(rand(3,10)*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
                        y2=y3;
                        cont_estado=4;
                        satavamp_fuego_id=satavamp_fuego(file,8,-100,-100);
                    end
                else
                    x3++;
                    if (x3>832)
                        enem_estado2=2;
                        y3=(rand(3,10)*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
                        y2=y3;
                        cont_estado=4;
                        satavamp_fuego_id=satavamp_fuego(file,8,-100,-100);
                    end
                end
                graph=2;
                x2=x3;
                //flotar
                angle2+=4000;
                y2=y3+(4*sin(angle2));
            end
            case 1:         //volar hacia la derecha
                flags=1;
                cont_estado++;
                switch (cont_estado)
                case 5:  graph=4; end
                case 10: graph=5; end
                case 15: graph=6; end
                case 20: graph=7; cont_estado=0; end
                end
                x3+=7;
                x2=x3;
                if (x2>862)
                    cont_estado=0;
                    angle2=0;
                    enem_estado=rand(0,2);
                    //say("nuevo enem estado: "+itoa(enem_estado));
                    //siguiente estado, primero hay que recolocarse... si procede
                    switch (enem_estado)
                    case 0:                 //pasamos a estado de recolocacin a la derecha
                        enem_estado=2;
                        enem_estado2=3;
                        y3=(rand(3,10)*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
                        y2=y3;
                        if (exists(satavamp_fuego_id)) signal(satavamp_fuego_id,s_kill); end
                    end
                    case 1:                 //teletransporte, saltamos a la espera
                        enem_estado2=1;
                        alpha=0;
                        if (exists(satavamp_fuego_id)) signal(satavamp_fuego_id,s_kill); end
                    end
                    case 2:                 //lanzamiento, ya que estamos en un lado...
                        enem_estado2=2;
                        y3=(rand(3,10)*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
                        y2=y3;
                        cont_estado=4;
                    end
                    end //switch
                end
            end
            case 2:         //volar hacia la izquierda
                flags=0;
                cont_estado++;
                switch (cont_estado)
                case 5:  graph=4; end
                case 10: graph=5; end
                case 15: graph=6; end
                case 20: graph=7; cont_estado=0; end
                end
                x3-=7;
                x2=x3;
                if (x2<450)
                    cont_estado=0;
                    angle2=0;
                    enem_estado=rand(0,2);
                    //say("nuevo enem estado: "+itoa(enem_estado));
                    //siguiente estado, primero hay que recolocarse... si procede
                    switch (enem_estado)
                    case 0:                 //pasamos a estado de recolocacin a la izquierda
                        enem_estado=2;
                        enem_estado2=4;
                        y3=(rand(3,10)*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
                        y2=y3;
                        if (exists(satavamp_fuego_id)) signal(satavamp_fuego_id,s_kill); end
                    end
                    case 1:                 //teletransporte, saltamos a la espera
                        enem_estado2=1;
                        alpha=0;
                        if (exists(satavamp_fuego_id)) signal(satavamp_fuego_id,s_kill); end
                    end
                    case 2:                 //lanzamiento, ya que estamos en un lado...
                        enem_estado2=1;
                        y3=(rand(3,10)*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
                        y2=y3;
                        cont_estado=4;
                    end
                    end //switch
                end
            end
            case 3:         //recolocar a la derecha
                //say("RIGHT x3: "+itoa(x3));
                if (x3>768)
                    graph=2;
                    flags=0;
                    x3--;
                    x2=x3;
                    //flotar
                    angle2+=4000;
                    y2=y3+(4*sin(angle2));
                else
                    enem_estado=0;
                    enem_estado2=0;
                end
            end
            case 4:         //recolocar a la izquierda
                //say("LEFT x3: "+itoa(x3));
                if (x3<544)
                    graph=2;
                    flags=1;
                    x3++;
                    x2=x3;
                    //flotar
                    angle2+=4000;
                    y2=y3+(4*sin(angle2));
                else
                    enem_estado=0;
                    enem_estado2=0;
                end
            end
            end //switch
        end
        
        case 3:                 //anillo de fuego
            switch (enem_estado2)
            case 0:             //generando el crculo
                graph=2;
                angle3+=4000;
                if (angle3==60000)
                    angle3=0;
                    hijos[cont]=fuego_espiritual(file, 
                                                 x3+(35*cos( (60000*cont) + 30000 ))  ,
                                                 y3+(35*sin( (60000*cont) + 30000 )) );
                    cont++;
                    if (cont==6)
                        enem_estado2=1;
                        angle3=30000;
                        cont=0;
                    end
                end
                //flotar
                angle2+=4000;
                y2=y3+(4*sin(angle2));
            end
            case 1:             //dando vueltas y lanzando
                angle3+=6000;
                cont_estado++;
                if (angle3>360000) angle3-=360000; end
                
                //al llegar a la cuenta, buscamos un fuego para lanzarlo
                if (cont_estado>=(14+(energia>>2)))
                    for (cont=0;cont<6;cont++)
                        if (hijos[cont]!=0)
                            hijos[cont].graph=11;
                            hijos[cont]=0;
                            cont_estado=0;
                            break;
                        end
                    end
                end
                
                //recorremos de nuevo la lista, actualizando valores del resto.
                //si no hay, cambia de estado2
                enem_estado2=2;
                for (cont=0;cont<6;cont++)
                    if (hijos[cont]!=0)
                        hijos[cont].x2=x3+(35*cos( angle3+(60000*cont) ));
                        hijos[cont].y2=y3+(35*sin( angle3+(60000*cont) ));
                        enem_estado2=1;
                    end
                end
                
                //enem_estado2 vale 2 si no quedan hijos, de lo contrario, vale 1
                //flotar
                angle2+=4000;
                y2=y3+(4*sin(angle2));
            end
            case 2:
                if (get_id(type fuego_espiritual))
                    //flotar
                    angle2+=4000;
                    y2=y3+(4*sin(angle2));
                else
                    enem_estado2=0;
                    cont=0;
                    angle3=0;
                    cont_estado=0;
                    enem_estado=rand(0,1);          //***************************************
                end
            end
            end //switch
        end
        case 4:                     //boleadoras
            switch (enem_estado2)
            case 0:             //generando bolas
                graph=2;
                cont_estado++;
                if (cont_estado >= (energia/10))
                    if (cont<=1)
                        hijos[cont]=fuego_espiritual2(file,x3+25,y3-14);
                        cont++;
                    else
                        cont=0;
                        cont_estado=0;
                        enem_estado2=1;
                        hijos[2]=fuego_boleadoras(x3+25,y3-14,hijos[0],hijos[1]);
                    end
                end
                //flotar
                angle2+=4000;
                y2=y3+(4*sin(angle2));
            end
            case 1:
                if (exists(hijos[2]))
                    //flotar
                    angle2+=4000;
                    y2=y3+(4*sin(angle2));
                else
                    cont=0;
                    cont_estado=0;
                    enem_estado2=0;
                    enem_estado=rand(0,1);      //*************************************************
                end
            end
            end
        end
        case 5:                 //bolas de fuego
            switch (enem_estado2)
            case 0:     //inicializacion
                cont=rand(1,5);
                enem_estado2=1;
            end
            case 1:
                graph=3;
                cont_estado++;
                if (cont_estado>= ((25+(energia/4))>>1) )
                    if (exists(info_prota.id_prota))
                        angle3=fget_angle(x3,y3,info_prota.id_prota.x2,info_prota.id_prota.y2);
                    end
                    lanza_fuego (file,x,y,angle3);
                    lanza_fuego (file,x,y,angle3+15000);
                    lanza_fuego (file,x,y,angle3-15000);
                    cont_estado=0;
                    cont--;
                    enem_estado2=2;
                end
                //flotar
                angle2+=4000;
                y2=y3+(4*sin(angle2));
            end
            case 2:
                graph=2;
                cont_estado++;
                if (cont_estado>= (25+(energia/4)) )
                    if (cont==0)
                        enem_estado=rand(0,1);          //**********************************************
                        enem_estado2=0;
                        angle3=0;
                    else
                        enem_estado2=1;
                    end
                    //enem_estado2=1;
                    cont_estado=0;
                end
                //flotar
                angle2+=4000;
                y2=y3+(4*sin(angle2));
            end
            end //switch
        end
        end //switch
        
        //**************************************
        //  ZONA DE IMPACTOS
        //**************************************
        //impacto con las balas
        if (alpha==255)
            temp=collision(type normal_shot);
            while (temp)
                if ((graph!=1) && (graph!=3))
                    //say("GOLPE");
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                end
                temp.energia=0;
                temp=collision(type normal_shot);
            end
            temp=collision(type espadazo);
            if (temp && (temp!=temp_espada))
                if ((graph!=1) && (graph!=3))
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                end
                temp_espada=temp;
            end
            if (energia<=0) break; end
        end
        
        //impacto con el prota
        if (exists(info_prota.id_prota) && (alpha==255))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=5;
                info_prota.dano_exp=2;
                if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                else info_prota.dano_vel_horiz=-20;
                end
            end
        end
        
        if (enem_estado!=2)
            if (exists(info_prota.id_prota))
                if (info_prota.id_prota.x<x) flags=0; else flags=1; end
            end
        end
        
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        
        if (graph==2)
            satavamp_capa_id.x=x;
            satavamp_capa_id.y=y;
            satavamp_capa_id.graph=20;
            satavamp_capa_id.alpha=alpha;
            satavamp_capa_id.flags=flags;
        else
            satavamp_capa_id.graph=0;
        end
        if ((satavamp_fuego_id!=0) && exists(satavamp_fuego_id))
            satavamp_fuego_id.x=x;
            satavamp_fuego_id.y=y;
            satavamp_fuego_id.flags=4+flags;
        end
        frame;
    end
    
    signal_event_1_3_accesories (s_kill);
    
    fade(200,200,200,255);
    frame(300);
    fade(100,100,100,255);
    graph=2;
    frame(5000);
    for (cont=0;cont<250;cont++)
        satavamp_capa_id.x=x;
        satavamp_capa_id.y=y;
        satavamp_capa_id.graph=20;
        satavamp_capa_id.alpha=alpha;
        satavamp_capa_id.flags=flags;
        if (mi_temblor!=0 && exists(mi_temblor))
            mi_temblor.energia=cont/50;
        else
            mi_temblor=enem_temblor(id,cont/50);
        end
        frame;
    end
    while (!out_region(id,0))
        x+=2;
        y-=2;
        angle-=6000;
        satavamp_capa_id.x=x;
        satavamp_capa_id.y=y;
        satavamp_capa_id.angle=angle;
        frame;
    end
    if (exists(satavamp_capa_id)) signal(satavamp_capa_id,s_kill); end
    
    frame(10000);
end


process nave_evento (x2, y2, graph, energia)
private
    int temp;
    int temp_espada;
begin
    file=enem_grafs[0][cte_event];
    loop
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        //impacto con las balas
        /*temp=collision(type normal_shot);
        if (temp)
            energia-=temp.energia;
            //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
            //say("el disparo tena energia: "+itoa(temp.energia));
            temp.energia=0;
            if (mi_temblor!=0 && exists(mi_temblor))
                mi_temblor.energia=3;
            else
                mi_temblor=enem_temblor(id,3);
            end
        end*/
        temp=get_id(type normal_shot);
        while (temp)
            if (abs(temp.x-x)<10)
                if (abs(temp.y-y)<6)
                    energia-=temp.energia;
                    temp.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                end
            end
            temp=get_id(type normal_shot);
        end
        temp=collision(type espadazo);
        if (temp && (temp!=temp_espada))
            energia-=temp.energia;
            if (mi_temblor!=0 && exists(mi_temblor))
                mi_temblor.energia=3;
            else
                mi_temblor=enem_temblor(id,3);
            end
            temp_espada=temp;
        end
        if (energia<=0) break; end
        frame;
    end
end

//**************************************************************************************************
process bblom_shot (file, int graph1, int graph2, x2, y2, angle, int angle2, energia, int ens_velocidad);
private
    int x3, y3;
    int resolution3;
    int vel_x, vel_y;
    int ens_animation_data[1];
    
    //variables temporales
    int cont;
    int shot_tile;
    int shot_tilex, shot_tiley;
    int shot_offsx, shot_offsy;
begin
    z=father.z-1;
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    vel_x=ens_velocidad*cos(angle2);
    vel_y=-ens_velocidad*sin(angle2);
    if (angle==180000)
        angle=0;
        flags=1;
    end
    
    //graph=501;
    ens_animation_data[0]=graph1;
    ens_animation_data[1]=graph2;
    graph=graph1;
    loop
        shot_tilex=((x3+vel_x)/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        shot_tiley=((y3+vel_y)/resolution3)/id_tscroll.tmapa[0].alto_tile;
        shot_offsx=((x3+vel_x)/resolution3)%id_tscroll.tmapa[0].ancho_tile;
        shot_offsy=((y3+vel_y)/resolution3)%id_tscroll.tmapa[0].alto_tile;
        shot_tile=obtener_tile(&durezas,shot_tilex,shot_tiley,0);
        
        vel_x=shot_colision_lateral(shot_offsx,shot_offsy,shot_tile,vel_x,resolution3);
        vel_y=shot_colision_vertical(shot_offsx,shot_offsy,shot_tile,vel_y,resolution3);
        
        x3+=vel_x;
        y3+=vel_y;
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        
        if (cont==5)
            cont=0;
            if (graph==ens_animation_data[1])
                graph=ens_animation_data[0];
            else
                graph++;
            end
        end
        cont++;
        
        if (exists(info_prota.id_prota))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=energia;
                info_prota.dano_exp=energia*2;
                //say(itoa(angle));
                if (vel_x > 0) info_prota.dano_vel_horiz=20;
                elsif (vel_x < 0) info_prota.dano_vel_horiz=-20;
                else
                    if (x2>info_prota.id_prota.x2) info_prota.dano_vel_horiz=-20;
                    else info_prota.dano_vel_horiz=20; end
                end
            end
        end
        
        if (energia==0) break; end
        //if (out_region(id,0)) break; end
        if ((x<-16) || (x>336) || (y<-64) || (y>256)) break; end
        
        frame;
    end
    
    //animacion explosion
    frame;
end

process blom (file,graph,x2,y2,energia, int max_y3, int min_y3, int vel_horiz, int blom_impulso, int max_gravedad,
              int aceleracin, int blomdano, int id_padre)
private
    int x3,y3;
    int resolution3;
    
    int vel_vert;
    //int bblom_gravedad;
    
    int enem_estado;            //0: cayendo
                                //1: deformando abajo
                                //2: deformando arriba
    
    int temp;
    int temp_espada;
begin
    z=-2;
    resolution3=100;
    x3=x2*resolution3;
    y3=y2*resolution3;
    
    id_padre.energia+=energia;
    
    //vel_horiz=150;
    loop
        switch (enem_estado)
        case 0:
            vel_vert+=aceleracin;
            if (vel_vert>max_gravedad) vel_vert=max_gravedad; end
            y3+=vel_vert;
            if (y3>30300)
                y3=30300;
                enem_estado=2;
            end
            
            if ((x3>max_y3) || (x3<min_y3)) vel_horiz=-vel_horiz; end
            x3+=vel_horiz;
        end
        case 2:
            vel_vert=-blom_impulso;
            enem_estado=0;
        end
        end //switch
        
        //************************
        //  ZONA DE COLISIONES
        //************************
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=blomdano;
                info_prota.dano_exp=blomdano+1;
                if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                else info_prota.dano_vel_horiz=-20;
                end
            end
        
            //impacto con las balas
            temp=collision(type normal_shot);
            while (temp)
                energia-=temp.energia;
                id_padre.energia-=temp.energia;
                temp.energia=0;
                if (mi_temblor!=0 && exists(mi_temblor))
                    mi_temblor.energia=3;
                else
                    mi_temblor=enem_temblor(id,3);
                end
                temp=collision(type normal_shot);
            end
                        
            temp=collision(type espadazo);
            if (temp && (temp!=temp_espada))
                energia-=temp.energia;
                id_padre.energia-=temp.energia;
                if (mi_temblor!=0 && exists(mi_temblor))
                    mi_temblor.energia=3;
                else
                    mi_temblor=enem_temblor(id,3);
                end
                temp_espada=temp;
            end
        end
        
        if (energia<=0) break; end
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    switch (graph)
    case 3:
        blom (file,4,x2,y2,32,max_y3+1200,min_y3-1200,110,180,300,3,4,id_padre);
        blom (file,4,x2,y2,32,max_y3+1200,min_y3-1200,-110,180,300,3,4,id_padre);
    end
    case 4:
        blom (file,5,x2,y2,16,max_y3+600,min_y3-600,90,210,300,4,3,id_padre);
        blom (file,5,x2,y2,16,max_y3+600,min_y3-600,-90,210,300,4,3,id_padre);
    end
    case 5:
        blom (file,6,x2,y2,8,max_y3+300,min_y3-300,90,280,300,5,2,id_padre);
        blom (file,6,x2,y2,8,max_y3+300,min_y3-300,-90,280,300,5,2,id_padre);
    end
    end //switch
end


process big_blom ()
private
    int x3,y3;
    int resolution3;
    
    int vel_horiz,vel_vert;
    //int bblom_gravedad;
    
    int enem_estado;            //0: cayendo
                                //1: deformando abajo
                                //2: deformando arriba
    int cont_estado;
    int bblom_ataque;
    int temp_angle;
    
    int temp;       //colisiones
    int temp_espada;
    
    int temp_wav,temp_canal;
begin
    file=enem_grafs[0][cte_event];
    graph=1;
    x2=14180;
    y2=0;
    z=-2;
    
    while(y2<224)
        y2++;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    energia=1000;
    enem_ener_interface(id);
    frame(10000);
    
    resolution3=100;
    x3=x2*resolution3;
    y3=y2*resolution3;
    
    //vel_horiz=100;
    cont_estado=300;
    
    loop
        switch (enem_estado)
        case 0:
            vel_vert+=1;
            if (vel_vert>200) vel_vert=200; end
            y3+=vel_vert;
            if (y3>30300)
                y3=30300;
                enem_estado=1;
            end
            
            if ((x3>1422300) || (x3<1400100)) vel_horiz=-vel_horiz; end
            x3+=vel_horiz;
        end
        case 1:
            if (size_x<125)
                size_x++;
                size_y--;
            else
                enem_estado=2;
            end
        end
        case 2:
            if (size_x>100)
                size_x--;
                size_y++;
            else
                vel_horiz=rand(-150,150);
                vel_vert=-150;
                enem_estado=0;
            end
        end
        end //switch
        
        //ataques
        cont_estado--;
        if (cont_estado<=0)
            switch (bblom_ataque)
            case 0:
                bblom_ataque=rand(0,9);
                switch(bblom_ataque)
                case 0..5: bblom_ataque=1; end
                case 6,7: bblom_ataque=2; end
                case 8,9: bblom_ataque=3; end
                end //switch
                //bblom_ataque=3;
            end
            case 1:
                temp_angle=fget_angle(x2,y2-96,info_prota.id_prota.x2,info_prota.id_prota.y2);
                bblom_shot (file,8,8,x2,y2-96,0,temp_angle,3,45);
                bblom_shot (file,8,8,x2,y2-96,0,temp_angle+20000,3,45);
                bblom_shot (file,8,8,x2,y2-96,0,temp_angle-20000,3,45);
                bblom_shot (file,8,8,x2,y2-96,0,temp_angle+40000,3,45);
                bblom_shot (file,8,8,x2,y2-96,0,temp_angle-40000,3,45);
                bblom_ataque=0;
                cont_estado=rand(2,4+(energia/500))*50;
            end
            case 2:
                //if (y3==30300)
                    super_guerrillero(x2/16,y2/16,enem_grafs[0][cte_s_flerrus],0);
                    energia-=25;
                    bblom_ataque=0;
                    //cont_estado=200;
                    cont_estado=rand(2,4+(energia/500))*50;
                //end
            end
            case 3:
                //if (y3==30300)
                    if (exists(info_prota.id_prota))
                        if (info_prota.id_prota.x<x) cont_estado=0; else cont_estado=1; end
                    else
                        cont_estado=rand(0,1);
                    end
                    guerrillero(x2/16,y2/16,enem_grafs[0][cte_flerris],cont_estado);
                    energia-=7;
                    bblom_ataque=0;
                    //cont_estado=200;
                    cont_estado=rand(2,4+(energia/500))*50;
                //end
            end
            end //switch
        end
        
        //************************
        //  ZONA DE COLISIONES
        //************************
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=6;
                info_prota.dano_exp=20;
                if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                else info_prota.dano_vel_horiz=-20;
                end
            end
        
            //impacto con las balas
            temp=collision(type normal_shot);
            while (temp)
                energia-=temp.energia;
                temp.energia=0;
                if (mi_temblor!=0 && exists(mi_temblor))
                    mi_temblor.energia=3;
                else
                    mi_temblor=enem_temblor(id,3);
                end
                temp=collision(type normal_shot);
            end
                        
            temp=collision(type espadazo);
            if (temp && (temp!=temp_espada))
                energia-=temp.energia;
                if (mi_temblor!=0 && exists(mi_temblor))
                    mi_temblor.energia=3;
                else
                    mi_temblor=enem_temblor(id,3);
                end
                temp_espada=temp;
            end
        end
        
        if (energia<=0) break; end
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    fade(200,200,200,255);
    frame(300);
    graph=2;
    size_x=100;
    size_y=100;
    fade(100,100,100,255);
    frame(5000);
    for (cont_estado=0;cont_estado<250;cont_estado++)
        if (mi_temblor!=0 && exists(mi_temblor))
            mi_temblor.energia=cont_estado/50;
        else
            mi_temblor=enem_temblor(id,cont_estado/50);
        end
        frame;
    end
    
    //cambio de tercio
    father.graph=7;
    temp_wav=load_wav("sfx/alarma.wav");
    temp_canal=play_wav(temp_wav,1);
    for (cont_estado=0;cont_estado<6;cont_estado++)
        fade (100,0,0,3);
        while (fading) frame; end
        fade (100,100,100,3);
        while (fading) frame; end
    end
    if (is_playing_wav(temp_canal)) stop_wav(temp_canal); end
    unload_wav(temp_wav);
    father.graph=0;
    
    //SUPER PANG
    vel_horiz=150;
    enem_estado=2;
    energia=128;
    loop
        switch (enem_estado)
        case 0:
            vel_vert+=1;
            if (vel_vert>200) vel_vert=200; end
            y3+=vel_vert;
            if (y3>30300)
                y3=30300;
                enem_estado=2;
            end
            
            if ((x3>1422300) || (x3<1400100)) vel_horiz=-vel_horiz; end
            x3+=vel_horiz;
        end
        case 2:
            vel_vert=-150;
            enem_estado=0;
        end
        end //switch
        
        //************************
        //  ZONA DE COLISIONES
        //************************
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if (collision(info_prota.id_prota))
                info_prota.dano_id=id;
                info_prota.dano_energia=6;
                info_prota.dano_exp=10;
                if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                else info_prota.dano_vel_horiz=-20;
                end
            end
        
            //impacto con las balas
            temp=collision(type normal_shot);
            while (temp)
                energia-=temp.energia;
                temp.energia=0;
                if (mi_temblor!=0 && exists(mi_temblor))
                    mi_temblor.energia=3;
                else
                    mi_temblor=enem_temblor(id,3);
                end
                temp=collision(type normal_shot);
            end
                        
            temp=collision(type espadazo);
            if (temp && (temp!=temp_espada))
                energia-=temp.energia;
                if (mi_temblor!=0 && exists(mi_temblor))
                    mi_temblor.energia=3;
                else
                    mi_temblor=enem_temblor(id,3);
                end
                temp_espada=temp;
            end
        end
        
        if (energia<=0) break; end
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    graph=0;
    
    blom (file,3,x2,y2,64,1422300+2400,1400100-2400,130,160,230,2,5,id);
    blom (file,3,x2,y2,64,1422300+2400,1400100-2400,-130,160,230,2,5,id);
    
    while (get_id(type blom)) frame; end
    
    fade(200,200,200,255);
    frame(300);
    fade(100,100,100,255);
    
    frame(20000);
    //loop frame; end
end

//**************************************************************************************************
//  EVENTOS
//**************************************************************************************************
process event_1_1 ()
private
    int fin_evento;
    int temp;
begin
    modificar_tile(&durezas,5,29,0,1);
    modificar_tile(&durezas,5,28,0,1);
    modificar_tile(&durezas,5,27,0,1);
    modificar_tile(&durezas,5,26,0,1);
    modificar_tile(&durezas,5,25,0,1);
    modificar_tile(&durezas,5,24,0,1);
    modificar_tile(&durezas,5,23,0,1);
    modificar_tile(&durezas,5,22,0,1);
    modificar_tile(&durezas,5,21,0,1);
    modificar_tile(&durezas,5,20,0,1);
    modificar_tile(&durezas,26,29,0,1);
    modificar_tile(&durezas,26,28,0,1);
    modificar_tile(&durezas,26,27,0,1);
    modificar_tile(&durezas,26,26,0,1);
    modificar_tile(&durezas,26,25,0,1);
    modificar_tile(&durezas,26,24,0,1);
    modificar_tile(&durezas,26,23,0,1);
    modificar_tile(&durezas,26,22,0,1);
    modificar_tile(&durezas,26,21,0,1);
    modificar_tile(&durezas,26,20,0,1);
    
    level_song=25;
    x2=info_prota.id_prota.x2;
    y2=info_prota.id_prota.y2;
    id_tscroll.id_target=id;
    while ((x2!=256) || (y2!=400))
        if (x2<256) x2++; end
        if (x2>256) x2--; end
        if (y2<400) y2++; end
        if (y2>400) y2--; end
        frame;
    end
    //say("camara movida");
    
    fin_evento=false;
    prota_control=false;
    while (get_id(type normal_shot)) frame; end
    //say("esperados disparos");
    
    //comienza la juerga
    enem_grafs[0][cte_event]=load_fpg("grafs/ghyppo.fpg");
    enem_grafs[1][cte_event]=true;
    temp=ghyppo(enem_grafs[0][cte_event]);
    enem_ener_interface(temp);
    
    while (temp.alpha<255) frame; end     //esperamos a que aparezca
    //frame(15000);                       //esperamos un poco
    
    //prota_control=true;
    while (exists(temp)) frame; end
    while (get_id(type croquis)) frame; end     //esperamos a que desaparezcan los mini-cocodrilos
    
    //fin de la juerga
    level_song=next_level;
    if (exists(info_prota.id_prota))
        prota_control=false;
        while ((x2!=info_prota.id_prota.x2) || (y2!=info_prota.id_prota.y2))
            if (x2<info_prota.id_prota.x2) x2++; end
            if (x2>info_prota.id_prota.x2) x2--; end
            if (y2<info_prota.id_prota.y2) y2++; end
            if (y2>info_prota.id_prota.y2) y2--; end
            frame;
        end
        id_tscroll.id_target=info_prota.id_prota;
        prota_control=true;
    end
    
    modificar_tile(&durezas,5,29,0,0);
    modificar_tile(&durezas,5,28,0,0);
    modificar_tile(&durezas,5,27,0,0);
    modificar_tile(&durezas,5,26,0,0);
    modificar_tile(&durezas,5,25,0,0);
    modificar_tile(&durezas,5,24,0,0);
    modificar_tile(&durezas,5,23,0,0);
    modificar_tile(&durezas,5,22,0,0);
    modificar_tile(&durezas,5,21,0,0);
    modificar_tile(&durezas,5,20,0,0);
    modificar_tile(&durezas,26,29,0,0);
    modificar_tile(&durezas,26,28,0,0);
    modificar_tile(&durezas,26,27,0,0);
    modificar_tile(&durezas,26,26,0,0);
    modificar_tile(&durezas,26,25,0,0);
    modificar_tile(&durezas,26,24,0,0);
    modificar_tile(&durezas,26,23,0,0);
    modificar_tile(&durezas,26,22,0,0);
    modificar_tile(&durezas,26,21,0,0);
    modificar_tile(&durezas,26,20,0,0);
    
    unload_fpg(enem_grafs[0][cte_event]);
    enem_grafs[1][cte_event]=false;
end

process event_1_2 ()
private
    int fin_evento;
    int dragon_id[0];
    
    int ladrillos_id[19]=5,3,2,1,1,2,3,5,3,2,1,1,2,3,5,3,2,1,1,1;
    
    int temp;
    int cont;
    int cont_ladrillo1,cont_ladrillo2;
begin
    level_song=25;
    x2=info_prota.id_prota.x2;
    y2=info_prota.id_prota.y2;
    id_tscroll.id_target=id;
    while ((x2!=3680) || (y2!=176))
        if (x2<3680) x2++; end
        if (x2>3680) x2--; end
        if (y2<176) y2++; end
        if (y2>176) y2--; end
        frame;
    end
    
    fin_evento=true;
    prota_control=false;
    while (get_id(type normal_shot)) frame; end
    //say("esperados disparos");
    
    enem_grafs[0][cte_event]=load_fpg("grafs/gravor.fpg");
    enem_grafs[1][cte_event]=true;
    
    dragon_id[0]=dragon_body(enem_grafs[0][cte_event],1,3840+68,296+68,10);
    
    while (dragon_id[0].energia==0) frame; end
    
    modificar_tile(&nivel,219,8,0,0);
    ts_actualiza_tiles(&id_tscroll);
    
    while (exists(dragon_id[0]))
        //say("tres");
        frame;
    end
    
    while (info_prota.id_prota.y2!=y2)
        if (y2<info_prota.id_prota.y2) y2++; end
        if (y2>info_prota.id_prota.y2) y2--; end
        frame;
    end
    
    level_song=next_level;
    temp=false;
    while (!temp)
        //tiramos un ladrillo
        cont_ladrillo1=rand(1,19);
        while (cont_ladrillo1>0)
            cont_ladrillo2++;
            if (cont_ladrillo2>19) cont_ladrillo2=0; end
            if (ladrillos_id[cont_ladrillo2]>0)
                cont_ladrillo1--;
            end
        end
        
        ladrillos_id[cont_ladrillo2]--;
        ladrillo_cae(220+cont_ladrillo2,16+ladrillos_id[cont_ladrillo2]);
        //comprobamos que se han caido los ladrillos
        temp=true;
        for (cont=0;cont<20;cont++)
            if (ladrillos_id[cont]>0) temp=false; break; end
        end
        
        for (cont=0;cont<25;cont++)
            y2=info_prota.id_prota.y2;
            frame;
        end
    end
    
    while (info_prota.id_prota.x2!=x2)
        y2=info_prota.id_prota.y2;
        if (x2<info_prota.id_prota.x2) x2++; end
        if (x2>info_prota.id_prota.x2) x2--; end
        frame;
    end
    id_tscroll.id_target=info_prota.id_prota;
    modificar_tile(&durezas,239,30,0,0);
    modificar_tile(&durezas,239,29,0,0);
    modificar_tile(&durezas,239,28,0,0);
    modificar_tile(&durezas,239,27,0,0);
    modificar_tile(&durezas,239,26,0,0);
    modificar_tile(&durezas,239,25,0,0);
end

process event_1_3 ()
private
    int fin_evento;
    int id_boss;
begin
    level_song=26;
    
    x2=info_prota.id_prota.x2;
    y2=info_prota.id_prota.y2;
    id_tscroll.id_target=id;
    while ((x2!=656) || (y2!=120))
        if (x2<656) x2++; end
        if (x2>656) x2--; end
        if (y2<120) y2++; end
        if (y2>120) y2--; end
        frame;
    end
    
    fin_evento=false;
    prota_control=false;
    while (get_id(type normal_shot)) frame; end
    signal_enemigos(s_kill);
    //say("esperados disparos");
    
    enem_grafs[0][cte_event]=load_fpg("grafs/satavamp.fpg");
    enem_grafs[1][cte_event]=true;
    
    id_boss=satavamp();
    
    while (exists(id_boss)) frame; end
    
    unload_fpg(enem_grafs[0][cte_event]);
    enem_grafs[1][cte_event]=false;
    
    prota_control=false;
    pausa_estado=0;
    
    next_level=3;
    next_sublevel=0;
    end_level_event(1);    //************************************
    while (exists(type end_level_event)) frame; end
    
    //next_level=3;
    //next_sublevel=0;
    end_level=true;
    //fade(100,100,100,255);
end


process event_3_1 ()
private
    int x3,y3;
    int contx,conty;
    int array_naves[9][6];
    int array_grafs[6]=3,1,2,3,2,1,2;
    
    int vel_horiz;
    int cont_naves;     //cuenta las naves de la ultima fila
    int event_filas;    //indica cual es la ltima fila de naves vivas
    
    int cont_disp, cont_nave_disp;
    
    int fin_evento;
begin
    modificar_tile(&durezas,231,14,0,1);
    modificar_tile(&durezas,231,13,0,1);
    modificar_tile(&durezas,231,12,0,1);
    modificar_tile(&durezas,231,11,0,1);
    modificar_tile(&durezas,210,14,0,1);
    modificar_tile(&durezas,210,13,0,1);
    modificar_tile(&durezas,210,12,0,1);
    modificar_tile(&durezas,210,11,0,1);
    
    level_song=26;
    x2=info_prota.id_prota.x2;
    y2=info_prota.id_prota.y2;
    id_tscroll.id_target=id;
    while ((x2!=3536) || (y2!=144))
        if (x2<3536) x2++; end
        if (x2>3536) x2--; end
        if (y2<144) y2++; end
        if (y2>144) y2--; end
        frame;
    end
    
    signal_enemigos(s_kill);
    
    enem_grafs[0][cte_event]=load_fpg("grafs/ships.fpg");
    enem_grafs[1][cte_event]=true;
    
    //colocacion de las naves
    fin_evento=false;
    prota_control=false;
    event_filas=9;
    x3=3708;
    y3=48;
    for (conty=0;conty<=6;conty++)
        for (contx=0;contx<=9;contx++)
            array_naves[contx][conty]=nave_evento(x3+(contx*25), y3+(conty*16), array_grafs[conty], 9-conty);
            //14-(2*conty));
        end
    end
    
    while (get_id(type normal_shot)) frame; end
    
    //say("naves generadas");
    while (x3!=3422)
        x3-=2;
        for (conty=0;conty<=6;conty++)
            for (contx=0;contx<=9;contx++)
                array_naves[contx][conty].x2=x3+(contx*25);
            end
        end
        frame;
    end
    
    //comienza la juerga
    prota_control=true;
    vel_horiz=-1;
    while (!fin_evento)
        fin_evento=true;
        x3+=vel_horiz;
        cont_naves=0;
        
        //llegados al tope, cambiamos de direccion y bajamos un pixel
        if ((x3==3397) || (x3==3451))
            vel_horiz=vel_horiz*(-1);
            if (y3 < (98+(16*(6-event_filas))) ) y3++; end
        end
        
        for (conty=0;conty<=6;conty++)
            for (contx=0;contx<=9;contx++)
                if (exists(array_naves[contx][conty]))
                    fin_evento=false;
                    array_naves[contx][conty].x2=x3+(contx*25);
                    array_naves[contx][conty].y2=y3+(conty*16);
                    if (conty==event_filas) cont_naves++; end
                end
            end
        end
        
        if (cont_naves==0) event_filas--; end
        
        if ((cont_disp<=0) && (!fin_evento))
            //say("entro: cont_disp "+itoa(cont_disp)+" fin evento "+itoa(fin_evento));
            conty=0;
            cont_nave_disp=rand(0,53);
            loop
                for (contx=0;contx<=9;contx++)
                    if (exists(array_naves[contx][conty]))
                        cont_nave_disp--;
                        if (cont_nave_disp<=0) break; end
                    end
                end
                if (cont_nave_disp<=0)
                    break;
                else
                    conty++;
                    if (conty>6) conty=0; end
                end
            end
            enem_normal_shot2(enem_grafs[0][cte_event],10,10,array_naves[contx][conty].x2,
                               array_naves[contx][conty].y2,0,-90000,5,50);
            cont_disp=rand(10,60);
            //say("salgo");
        else
            cont_disp--;
        end
        
        frame;
    end
    
    
    //while (get_id(type disparonave)) frame; end
    
    level_song=next_level;
    if (exists(info_prota.id_prota))
        prota_control=false;
        while ((x2!=info_prota.id_prota.x2) || (y2!=info_prota.id_prota.y2))
            if (x2<info_prota.id_prota.x2) x2++; end
            if (x2>info_prota.id_prota.x2) x2--; end
            if (y2<info_prota.id_prota.y2) y2++; end
            if (y2>info_prota.id_prota.y2) y2--; end
            frame;
        end
        id_tscroll.id_target=info_prota.id_prota;
        prota_control=true;
    end
    modificar_tile(&durezas,231,14,0,0);
    modificar_tile(&durezas,231,13,0,0);
    modificar_tile(&durezas,231,12,0,0);
    modificar_tile(&durezas,231,11,0,0);
    modificar_tile(&durezas,210,14,0,0);
    modificar_tile(&durezas,210,13,0,0);
    modificar_tile(&durezas,210,12,0,0);
    modificar_tile(&durezas,210,11,0,0);
    
    unload_fpg(enem_grafs[0][cte_event]);
    enem_grafs[1][cte_event]=false;
end

process event_3_2 ()                    //PURGA DE ENEMIGOS
private
    int temp;
begin
    //procesos que usan enemigos
    temp=get_id(type enem_temblor);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type enem_temblor);
    end
    
    temp=get_id(type enem_temblor2);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type enem_temblor2);
    end
    
    temp=get_id(type enem_xtemblor);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type enem_xtemblor);
    end
    
    temp=get_id(type enem_smoke);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type enem_smoke);
    end
    
    temp=get_id(type visual_fx);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type visual_fx);
    end
    
    //disparos
    temp=get_id(type enem_normal_shot);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type enem_normal_shot);
    end
    
    temp=get_id(type enem_normal_shot2);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type enem_normal_shot2);
    end
    
    temp=get_id(type enem_canon_shot);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type enem_canon_shot);
    end
    
    //enemigos
    temp=get_id(type blobo);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type blobo);
    end
    
    temp=get_id(type canon);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type canon);
    end
    
    temp=get_id(type corvo);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type corvo);
    end
    
    temp=get_id(type flozat);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type flozat);
    end
    
    temp=get_id(type ghost_fly);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type ghost_fly);
    end
    
    temp=get_id(type ghost_fly_invencible);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type ghost_fly_invencible);
    end
    
    temp=get_id(type glotz);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type glotz);
    end
    
    temp=get_id(type guerrillero);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type guerrillero);
    end
    
    temp=get_id(type invencible_enem);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type invencible_enem);
    end
    
    temp=get_id(type mina);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type mina);
    end
    
    temp=get_id(type murcielago);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type murcielago);
    end
    
    temp=get_id(type spider);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type spider);
    end
    
    temp=get_id(type super_guerrillero);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type super_guerrillero);
    end
    
    temp=get_id(type volador1);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type volador1);
    end
    
    temp=get_id(type volador2);
    while (temp)
        if (temp.x<-50) signal(temp,s_kill); end
        temp=get_id(type volador2);
    end
end



process event_3_3 ()
private
    int fin_evento;
    int id_boss;
    
    int cont;
    int temp_wav,temp_canal;
begin
    level_song=0;
    
    x2=info_prota.id_prota.x2;
    y2=info_prota.id_prota.y2;
    id_tscroll.id_target=id;
    while ((x2!=14112) || (y2!=224))
        if (x2<14112) x2++; end
        if (x2>14112) x2--; end
        if (y2<224) y2++; end
        if (y2>224) y2--; end
        frame;
    end
    
    modificar_tile(&durezas,891,18,0,253);
    modificar_tile(&durezas,872,18,0,254);
    
    fin_evento=false;
    //prota_control=false;
    while (get_id(type normal_shot)) frame; end
    signal_enemigos(s_kill);
    //say("esperados disparos");
    
    enem_grafs[0][cte_event]=load_fpg("grafs/blom.fpg");
    enem_grafs[1][cte_event]=true;
    
    x=160;
    y=120;
    file=enem_grafs[0][cte_event];
    graph=7;
    
    temp_wav=load_wav("sfx/alarma.wav");
    temp_canal=play_wav(temp_wav,1);
    for (cont=0;cont<6;cont++)
        fade (100,0,0,3);
        while (fading) frame; end
        fade (100,100,100,3);
        while (fading) frame; end
    end
    graph=0;
    if (is_playing_wav(temp_canal)) stop_wav(temp_canal); end
    unload_wav(temp_wav);
    
    level_song=26;
    
    id_boss=big_blom();
    
    while (exists(id_boss)) frame; end
    
    unload_fpg(enem_grafs[0][cte_event]);
    enem_grafs[1][cte_event]=false;
    
    prota_control=false;
    pausa_estado=0;
    
    end_level_event(3);    //************************************
    while (exists(type end_level_event)) frame; end
    
    //loop frame; end
    next_level=0;
    next_sublevel=0;
    global_mode=4;
    end_level=true;
    //fade(100,100,100,255);
end


function event (x2,y2)
begin
    modificar_tile(&nivel,x2,y2,0,0);
    switch (next_level)
    case 1:
        switch (obtener_tile(&durezas,x2,y2,0)-150)
        case 1: event_1_1(); end
        case 2: event_1_2(); end
        case 3: event_1_3(); end
        end //switch
    end
    case 3:
        switch (obtener_tile(&durezas,x2,y2,0)-150)
        case 1: event_3_1(); end
        case 2: event_3_2(); end //matar todos los enemigos con x<-50
        case 3: event_3_3(); end //super pang
        end //switch
    end
    end //switch
end