CONST
    cte_prota_max_vel=20;
    cte_prota_acelerac=2;
    cte_prota_salto=30;
    cte_prota_max_salto=10;
    cte_prota_gravedad=2;
    cte_prota_max_gravedad=30;
    //constantes de velocidad de la moto
    cte_moto_max_vel=30;
    cte_moto_acelerac=2;
    cte_moto_salto=30;
    cte_moto_max_salto=5;//20;
    cte_moto_gravedad=2;
    cte_moto_max_gravedad=30;
    
    //constantes de lo que se activa con los interruptores
    cte_interruptores=15;
    cte_door=0;
    cte_bridge=1;
END

GLOBAL
    //variables del scroll del mapa
    t_mapa durezas;
    t_mapa nivel;
    tscroll id_tscroll;
    
    //constantes de movimiento
    //var_vel;
    var_salto;
    var_gravedad;
    cont_salto;
    //variables del prota
    p_dur[2][2];    //tiles que rodean al protagonista
    p_dir;          //indica la direccin hacia la que cambia de tile (cambia segn los tiles que rodean al prota)
    p_dir_ini;      //direccin inicial de cambio de tile
    struct info_prota
        int id_prota;
        //datos del juego
        int p_energ;       //energa restante del prota
        int p_max_energ;
        int p_invencible;  //indica el tiempo que es invencible (por tocar enemigo o similar)
        //info de posicin
        int p_tilex;
        int p_tiley;
        int p_offsx;
        int p_offsy;
        //info de movimiento
        int auto_mov;
        int vel_horiz;
        int vel_vert;
        int p_mover_h;
        int p_mover_v;
        int estado;     // 0: parado
                        // 1: andando
                        // 2: saltando
                        // 3: cayendo
        //int estado_ant;
        int anim;       //como estado, pero referente a la animacin que debe hacer (puede tener grfico distinto
                        //a su estado, por ejemplo, cayendo, pero terminando el salto aun mira arriba)
                        // 0: parado
                        // 1: andando
                        // 2: saltando
                        // 3: cayendo
        int anim_ant;
        //info de daos
        int dano_id;        //proceso que causa daos
        int dano_energia;   //energia que quita el golpe
        int dano_exp;       //exp del arma que quita el golpe
        int dano_vel_horiz; //retroceso del impacto
        int dano_time;      //tiempo que deja de responder por el dao recibido
        int vidas;          //numero de vidas restantes
    end
    
    //ANIMACIONES
    int prota_file;
    int animation_prota_cont;       //sirve para contar frames antes del prximo cuadro de animacin
    int animation_prota_data[2];    //0: inicio animacin, 1: final animacin, 2: posicin actual animacin
    //el primer valor indica nmero de imgenes de dicha animacin, el resto son graphs
    int animation_prota[]=15,1,1,1,1,1,1,1,1,1,1,1,2,1,1,2, //0:    animacin parado
                          4,1,5,1,6,                        //1:    animacin andando
                          1,10,                             //2:    animacin salto
                          1,11,                             //3:    animacin cayendo
                          1,15,                             //4:    animacin parado mirando arriba
                          4,15,16,15,17,                    //5:    animacin andando mirando arriba
                          1,18;                             //6:    animacin salto mirando arriba
    
    //****************************************
    //ARMAS
    int  armas_file;
    int  armas_id[2];               //procesos de la interfaz
    byte armas_get[3]=true,false,false,false;
    //byte armas_get[3]=false,true,true,true;
    int  armas_select;
    int  armas_curr_level;
    int  armas_level[3][3];         //0:nivel del arma  1:max nivel 1   2:max nivel 2   3:max nivel 3
    byte armas_damage[3][2];        //dao que hace cada arma
    int  armas_animation[]=0,                             //sin arma
                           0,                             //sin arma
                           0,                             //sin_arma
                           0,                             //sin arma, vertical
                           0,                             //sin arma, vertical
                           0,                             //sin_arma, vertical
                           1,501,                           //normal shot lvl 1
                           1,502,                           //normal shot lvl 2
                           1,503,                           //normal shot lvl 3
                           1,504,                           //normal shot lvl 1, vertical
                           1,505,                           //normal shot lvl 2, vertical
                           1,506,                           //normal shot lvl 3, vertical
                           8,512,513,514,514,514,514,513,512,   //espada lvl 1
                           8,515,516,517,517,517,517,516,515,   //espada lvl 2
                           8,518,519,520,520,520,520,519,518,   //espada lvl 3
                           1,527,                               //espada slash
                           0,
                           0,
                           1,521,                           //normal shot lvl 1
                           1,522,                           //normal shot lvl 2
                           1,523,                           //normal shot lvl 3
                           1,524,                           //normal shot lvl 1, vertical
                           1,525,                           //normal shot lvl 2, vertical
                           1,526;                           //normal shot lvl 3, vertical
               
    //*****************************************
    //JUEGO
    int dificultad;
    int next_level;         //indica un cambio de nivel de juego
    int next_sublevel;      //indica cambio a otra pantalla del mismo nivel (exteriores a castillo)
    int init_level;         //indica en qu comienzo del (sub)nivel debemos empezar
    int end_level;          //avisa de que se ha terminado el nivel (incluye muerte)
    
    int interfaz_grafs[19];
    int enem_grafs[1][cte_enem_last];
    int item_grafs;
    int explosion_grafs;
    
    int interruptores[cte_interruptores];   //guardan el estado de cada botn/interruptor activable del nivel
    int obj_interruptor[1];                 //indican el grfico de cada cosa que es activada por un boton
                                            //0: puerta
                                            //1: puente
    
    int prota_control;              //false: no funcionan botones direccin, salto ni disparo
    int pausa_estado;
    
    //*******************************************
    //SONIDO
    int level_song;
    int level_song_id[1];           //0: id de la musica        1: hay una msica cargada
    int disparo_wav[1][2];
    int sfx_id[1][cte_sfx_last];
END

//**************************************************
//   USO DE REGIONES
//   0: NORMAL
//   1: VOLUMEN
//   2: GET WEAPON, TITULO NIVEL, MENU PORTADA
//**************************************************
