function search_animation (int pointer anim_array, int anim_pos)
private
    cont;
    dato_a_devolver;
begin
    dato_a_devolver=0;
    for (cont=0;cont<anim_pos;cont++)
        dato_a_devolver+=anim_array[dato_a_devolver]+1;
    end
    return (dato_a_devolver);
end

//**************************************************************************************************
//  LO QUE ACTIVAN LOS INTERRUPTORES
//**************************************************************************************************

process door (x3,y3,file,graph)
private
    int mi_activacion;
begin
    //say("puerta, grafico: "+itoa(graph));
    modificar_tile(&nivel,x3,y3,0,0);
    priority=-99;
    x2=(x3*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(y3*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
    
    mi_activacion=obtener_tile(&durezas,x3,y3,0)-150;
    //say("activacion: "+itoa(mi_activacion));
    modificar_tile(&durezas,x3,y3  ,0,1);
    modificar_tile(&durezas,x3,y3-1,0,1);
    while (!interruptores[mi_activacion])
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    play_wav(sfx_id[0][cte_sfx_door],0);
    //say("aqui no deberia estar");
    modificar_tile(&durezas,x3,y3  ,0,0);
    modificar_tile(&durezas,x3,y3-1,0,0);
    modificar_tile(&nivel  ,x3,y3  ,0,graph+1);
    ts_actualiza_tiles(&id_tscroll);
end

process bridge (x3,y3,file, int graph2, int bridge_dir, int bridge_long, int bridge_on)
private
    int mi_activacion;
    int x2_ini;
    int vel_horiz;
    
    int cont1;
    int cont2;
begin
    z=1;
    modificar_tile(&nivel,x3,y3,0,0);
    ts_actualiza_tiles(&id_tscroll);
    priority=-99;
    mi_activacion=obtener_tile(&durezas,x3,y3,0)-150;
    
    //say ("dureza: "+itoa(obtener_tile(&durezas,x3,y3-1,0)));
    
    if (bridge_dir==2)
        if (obtener_tile(&durezas,x3-1,y3,0)==1)
            bridge_dir=0;
        else
            bridge_dir=1;
        end
    end
    
    x2=(x3*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(y3*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
    switch (bridge_dir)
    case 0:
        x2-=id_tscroll.tmapa[0].ancho_tile;
        vel_horiz=1;
    end
    case 1:
        x2+=id_tscroll.tmapa[0].ancho_tile;
        vel_horiz=-1;
    end
    end //switch
    x2_ini=x2;
    
    while (!interruptores[mi_activacion] && !bridge_on)
        frame;
    end
    
    if (!bridge_on) play_wav(sfx_id[0][cte_sfx_bridge],bridge_long); end
    
    graph=graph2;
    for (cont1=bridge_long;cont1>0;cont1--)     //repetimos tantas veces como longitud
        x2=x2_ini;
        for (cont2=0;cont2<id_tscroll.tmapa[0].ancho_tile;cont2++)  //movemos 16 veces
            x2+=vel_horiz;
            tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
            frame;
        end
        //tras mover, modificamos el mapa de durezas
        modificar_tile(&durezas,x3,y3,0,25);
        //y creamos otro trozo del puente
        if ((bridge_long>1) && (cont1==bridge_long))
            bridge (x3+vel_horiz,y3,file,graph,bridge_dir,bridge_long-1,true);
        end
    end
    
    //y por ltimo, cambiamos el grfico en el mapa visible
    modificar_tile(&nivel,x3,y3,0,graph);
    ts_actualiza_tiles(&id_tscroll);
end

//**************************************************************************************************
//  INTERRUPTORES
//**************************************************************************************************

process button (x3,y3,file,graph)
private
    button_activate;
    temp;
begin
    modificar_tile(&nivel,x3,y3,0,0);
    priority=-99;
    x2=(x3*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(y3*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
    
    button_activate=obtener_tile(&durezas,x3,y3,0)-150;
    
    loop
        temp=collision(type normal_shot);
        if (temp)
            if (temp.graph!=527)
                temp.energia=0;
                break;
            end
        end
        
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    modificar_tile(&nivel,x3,y3,0,101);
    ts_actualiza_tiles(&id_tscroll);
    interruptores[button_activate]=true;
end
    
//**************************************************************************************************
//  FUNCIONES PRINCIPALES
//**************************************************************************************************

function search_start_point (t_mapa pointer stp_nivel, t_mapa pointer stp_durezas, int n_start,
                             int pointer stpx, int pointer stpy)
private
    cont1;
    cont2;
    temp;
    encontrado;
begin
    encontrado=false;
    for(cont2=0;cont2<[stp_nivel].filas;cont2++)
        for(cont1=0;cont1<[stp_nivel].columnas;cont1++)
            if (100 == obtener_tile(&nivel,cont1,cont2,0))
            //if (253 == obtener_tile(&nivel,cont1,cont2,0))
                if (n_start == (obtener_tile(&durezas,cont1,cont2,0)-150) )
                    encontrado=true;
                    [stpx]=cont1;
                    [stpy]=cont2;
                    //modificar_tile(&nivel,cont1,cont2,0,0);
                    //modificar_tile(&durezas,cont1,cont2,0,0);
                    break;
                end
            end
        end
        if (encontrado) break; end
    end
end


process game ()
private
    int pausa_id;
    int cont;
begin
    //init_level=0;
    //next_level=1;
    //next_sublevel=0;
    end_level=false;
    
    prota_file=load_fpg("grafs/prota.fpg");
    armas_file=load_fpg("grafs/weapons.fpg");
    //init_weapons();
    armas_select=0;
    armas_curr_level=0;
        //armas_select=1; 
        //armas_get[0]=false;
        //armas_get[1]=true;
        //armas_get[2]=true;
        //armas_get[3]=true;
        //info_prota.vidas=1;
    
    item_grafs=load_fpg("grafs/items.fpg");
    explosion_grafs=load_fpg("grafs/explos.fpg");
    
    pausa_id=pausa();
    load_interface();
    
    //inicializacion de datos
    //info_prota.p_max_energ=10;
    //info_prota.p_energ=10;
    //armas_level[0][0]=0;
    //armas_level[1][0]=0;
    //armas_level[2][0]=0;
    //armas_level[3][0]=0;
    
    //refresh_interface();
    //pausa_estado=1;                 //DEBUG*********************
    
    loop
        //inicializacin de los botones
        for (cont=0;cont<=cte_interruptores;cont++)
            interruptores[cont]=false;
        end
        info_prota.p_invencible=2;
        
        switch (next_level)
        case 0:     //salir al menu
            break;
        end
        
        case 1:
            //debug lines
            //armas_select=3;
            
            //carga de grficos de enemigos
            enem_grafs[0][cte_blobo]=load_fpg("grafs/blobo.fpg");
            enem_grafs[0][cte_ghost_fly]=load_fpg("grafs/hedghost.fpg");
            enem_grafs[0][cte_murcielago]=load_fpg("grafs/murphy.fpg");
            enem_grafs[0][cte_spider]=load_fpg("grafs/spider.fpg");
            enem_grafs[0][cte_volador1]=load_fpg("grafs/corvo.fpg");
            enem_grafs[0][cte_hotta]=load_fpg("grafs/hotta.fpg");
            
            enem_grafs[1][cte_blobo]=true;
            enem_grafs[1][cte_ghost_fly]=true;
            enem_grafs[1][cte_murcielago]=true;
            enem_grafs[1][cte_spider]=true;
            enem_grafs[1][cte_volador1]=true;
            enem_grafs[1][cte_hotta]=true;
            
            enem_grafs[0][cte_level]=load_fpg("grafs/level01bg.fpg");
            enem_grafs[1][cte_level]=true;
            
            //enem_grafs[0][cte_ghyppo]=load_fpg("grafs/ghyppo.fpg");
            
            sfx_id[0][cte_sfx_door]=load_wav("sfx/door.wav");
            sfx_id[0][cte_sfx_bridge]=load_wav("sfx/bridge.wav");
            
            sfx_id[1][cte_sfx_door]=true;
            sfx_id[1][cte_sfx_bridge]=true;
            
            //indicacin de grficos de los objetos que se mueven al activar botones
            obj_interruptor[cte_door]=41;
            obj_interruptor[cte_bridge]=40;
            
            set_interface();
            refresh_interface();
            
            //carga del mapa y del entorno
            switch (next_sublevel)
            case 0:
                if (load_tmf("levels/lvl1_0_castlehorror.dur.tmf",&durezas) &&
                    load_tmf("levels/lvl1_0_castlehorror.tmf",&nivel)     )
                    
                    map_clear(0,0,rgb(0,0,64));
                    drawing_map(0,0);
                    drawing_color(rgb(255,255,212));
                    draw_fcircle(250,40,28);
                    put(enem_grafs[0][cte_level],1,17,70);
                    put(enem_grafs[0][cte_level],1,75,45);
                    put(enem_grafs[0][cte_level],2,30,135);
                    put(enem_grafs[0][cte_level],1,82,120);
                    //put(enem_grafs[0][cte_level],2,24,204);
                    //put(enem_grafs[0][cte_level],1,109,175);
                    put(enem_grafs[0][cte_level],2,121,78);
                    put(enem_grafs[0][cte_level],2,181,48);
                    put(enem_grafs[0][cte_level],1,178,141);
                    put(enem_grafs[0][cte_level],1,209,91);
                    put(enem_grafs[0][cte_level],2,275,116);
                    //put(enem_grafs[0][cte_level],1,230,189);
                    
                    //level_song=next_level;
                else
                    say("no se encuentra el mapa");
                    next_level=0;
                end
            end //case sublevel 0
            case 1:
                if (load_tmf("levels/lvl1_1_castlehorror.dur.tmf",&durezas) &&
                    load_tmf("levels/lvl1_1_castlehorror.tmf",&nivel)     )
                
                    map_clear(0,0,rgb(0,0,0));
                    
                else
                    say("no se encuentra el mapa");
                    next_level=0;
                end
            end //case sublevel 1
            case 2:
                if (load_tmf("levels/lvl1_2_castlehorror.dur.tmf",&durezas) &&
                    load_tmf("levels/lvl1_2_castlehorror.tmf",&nivel)     )
                
                    map_clear(0,0,rgb(0,0,64));
                    drawing_map(0,0);
                    drawing_color(rgb(255,255,212));
                    draw_fcircle(250,40,28);
                    put(enem_grafs[0][cte_level],1,17,70);
                    put(enem_grafs[0][cte_level],1,75,45);
                    put(enem_grafs[0][cte_level],2,30,135);
                    put(enem_grafs[0][cte_level],1,82,120);
                    //put(enem_grafs[0][cte_level],2,24,204);
                    //put(enem_grafs[0][cte_level],1,109,175);
                    put(enem_grafs[0][cte_level],2,121,78);
                    put(enem_grafs[0][cte_level],2,181,48);
                    put(enem_grafs[0][cte_level],1,178,141);
                    put(enem_grafs[0][cte_level],1,209,91);
                    put(enem_grafs[0][cte_level],2,275,116);
                    //put(enem_grafs[0][cte_level],1,230,189);
                else
                    say("no se encuentra el mapa");
                    next_level=0;
                end
            end //case sublevel 2
            case 3:
                if (load_tmf("levels/lvl1_3_castlehorror.dur.tmf",&durezas) &&
                    load_tmf("levels/lvl1_3_castlehorror.tmf",&nivel)     )
                
                    map_clear(0,0,rgb(0,0,0));
                    
                else
                    say("no se encuentra el mapa");
                    next_level=0;
                end
            end //case sublevel 3
            end //switch
            
            
            if (next_level!=0)
                start_tscroll(&id_tscroll,&nivel,0,0,0,320,240,4,4,16,16,0);
                //id_tscroll.ts_file=load_fpg("levels/durezas.fpg");
                id_tscroll.ts_file=load_fpg("grafs/level01.fpg");
                ts_actualiza_tiles(&id_tscroll);
                
                
                if (search_start_point(&nivel,&durezas,init_level,&x2,&y2))
                    modificar_tile(&nivel,x2,y2,0,0);     //no es necesario, basta con borrar el tile del fpg
                    ts_actualiza_tiles(&id_tscroll);
                    id_tscroll.id_target=prota(x2,y2);
                    //id_tscroll.id_target=prota_moto(x2,y2);
                    
                    level_song=next_level;
                    
                    //say("next sublevel: "+itoa(next_sublevel));
                    switch (next_sublevel)
                    case 0:
                        //evento de presentacin de nivel
                        intro_nivel(1);
                        signal(id,s_freeze);
                        frame;
                        /*fade(100,100,100,1);
                        while (fading); frame; end*/
                        prota_control=true;
                        pausa_estado=1;
                    end
                    default:
                        fade(100,100,100,3);
                        while (fading); frame; end
                        prota_control=true;
                        pausa_estado=1;
                    end
                    end //switch
                else
                    say("error: no hay inicio");
                end
                
                end_level=false;
                while (!end_level)
                    /*if (teclas[k_esc][2]==1)
                        next_level=99;
                        global_mode=100;
                        end_level=true;
                    end
                    if (key(_f12))
                        next_level=3;
                        end_level=true;
                    end*/
                    frame;
                end
                
                unload_fpg(id_tscroll.ts_file);
                stop_tscroll(&id_tscroll);
                if (exists(info_prota.id_prota)) signal(info_prota.id_prota,s_kill_tree); end
            end
                
            signal_items(s_kill);
            signal_enemigos(s_kill);
            signal_event_all(s_kill);
            
            unload_all_enem_fpgs();
            /*unload_fpg(enem_grafs[0][cte_blobo]);
            unload_fpg(enem_grafs[0][cte_ghost_fly]);
            unload_fpg(enem_grafs[0][cte_murcielago]);
            unload_fpg(enem_grafs[0][cte_spider]);
            unload_fpg(enem_grafs[0][cte_volador1]);
            unload_fpg(enem_grafs[0][cte_hotta]);
            
            enem_grafs[1][cte_blobo]=false;
            enem_grafs[1][cte_ghost_fly]=false;
            enem_grafs[1][cte_murcielago]=false;
            enem_grafs[1][cte_spider]=false;
            enem_grafs[1][cte_volador1]=false;
            enem_grafs[1][cte_hotta]=false;
            //unload_fpg(enem_grafs[0][cte_ghyppo]);
            
            unload_fpg(enem_grafs[0][cte_level]);
            enem_grafs[1][cte_level]=false;*/
            
            stop_wav(-1);
            unload_wav(sfx_id[0][cte_sfx_door]);
            unload_wav(sfx_id[0][cte_sfx_bridge]);
            
            sfx_id[1][cte_sfx_door]=false;
            sfx_id[1][cte_sfx_bridge]=false;
            
            unset_interface();
            
            //main lines
            //search_start_point(&nivel,&durezas,0,&x2,&y2);
        end
        
        case 3:
            //debug lines
            //armas_select=1;
            
            enem_grafs[0][cte_guerrillero]=load_fpg("grafs/guerrillero.fpg");
            enem_grafs[0][cte_spider]=load_fpg("grafs/metal_spider.fpg");
            enem_grafs[0][cte_s_guerrillero]=load_fpg("grafs/super_g.fpg");
            enem_grafs[0][cte_zenerg]=load_fpg("grafs/zenerg.fpg");
            enem_grafs[0][cte_mina]=load_fpg("grafs/mina.fpg");
            enem_grafs[0][cte_volador1]=load_fpg("grafs/robcop.fpg");
            enem_grafs[0][cte_flozat]=load_fpg("grafs/flozat.fpg");
            enem_grafs[0][cte_glotz]=load_fpg("grafs/glotz.fpg");
            enem_grafs[0][cte_canon]=load_fpg("grafs/canon.fpg");
            enem_grafs[0][cte_flerris]=load_fpg("grafs/flerris.fpg");
            enem_grafs[0][cte_s_flerrus]=load_fpg("grafs/s_flerrus.fpg");
            
            enem_grafs[1][cte_guerrillero]=true;
            enem_grafs[1][cte_spider]=true;
            enem_grafs[1][cte_s_guerrillero]=true;
            enem_grafs[1][cte_zenerg]=true;
            enem_grafs[1][cte_mina]=true;
            enem_grafs[1][cte_volador1]=true;
            enem_grafs[1][cte_flozat]=true;
            enem_grafs[1][cte_glotz]=true;
            enem_grafs[1][cte_canon]=true;
            enem_grafs[1][cte_flerris]=true;
            enem_grafs[1][cte_s_flerrus]=true;
            
            sfx_id[0][cte_sfx_shot]=load_wav("sfx/shot.wav");
            sfx_id[0][cte_sfx_door]=load_wav("sfx/door.wav");
            sfx_id[0][cte_sfx_bridge]=load_wav("sfx/bridge.wav");
            
            sfx_id[1][cte_sfx_shot]=true;
            sfx_id[1][cte_sfx_door]=true;
            sfx_id[1][cte_sfx_bridge]=true;
            
            //indicacin de grficos de los objetos que se mueven al activar botones
            obj_interruptor[cte_door]=60;
            obj_interruptor[cte_bridge]=62;
            
            set_interface();
            refresh_interface();
            
            
            if (load_tmf("levels/lvl3_city.dur.tmf",&durezas) &&
                load_tmf("levels/lvl3_city.tmf",&nivel)     )
            
                map_clear(0,0,rgb(255,96,0));
                start_tscroll(&id_tscroll,&nivel,0,0,0,320,240,4,4,16,16,0);
                //id_tscroll.ts_file=load_fpg("levels/durezas.fpg");
                id_tscroll.ts_file=load_fpg("grafs/level03.fpg");
                ts_actualiza_tiles(&id_tscroll);
                
                //play_level_music(next_level);
                level_song=next_level;
                
                if (search_start_point(&nivel,&durezas,init_level,&x2,&y2))
                    modificar_tile(&nivel,x2,y2,0,0);     //no es necesario, basta con borrar el tile del fpg
                    ts_actualiza_tiles(&id_tscroll);
                    
                    /*x2=870;
                    y2=3;
                    info_prota.vidas=5;*/
                    
                    id_tscroll.id_target=prota(x2,y2);
                    //id_tscroll.id_target=prota_moto(x2,y2);
                    
                    //evento de presentacin de nivel
                    intro_nivel(2);
                    signal(id,s_freeze);
                    frame;
                    
                        
                    prota_control=true;
                    pausa_estado=1;
                else
                    say("error: no hay inicio");
                end
                end_level=false;
                //next_level=0;
                //while (teclas[k_esc][2]==0) frame; end
                while (!end_level)
                    /*if (teclas[k_esc][2]==1)
                        next_level=99;
                        global_mode=100;
                        end_level=true;
                    end*/
                    frame;
                end
                
                unload_fpg(id_tscroll.ts_file);
                stop_tscroll(&id_tscroll);
                if (exists(info_prota.id_prota)) signal(info_prota.id_prota,s_kill_tree); end
            else
                say("no se encuentra el mapa");
                next_level=0;
            end
            
            signal_items(s_kill);
            signal_enemigos(s_kill);
            signal_event_all(s_kill);
            
            unload_all_enem_fpgs();
            /*unload_fpg(enem_grafs[0][cte_guerrillero]);
            unload_fpg(enem_grafs[0][cte_spider]);
            unload_fpg(enem_grafs[0][cte_s_guerrillero]);
            unload_fpg(enem_grafs[0][cte_zenerg]);
            unload_fpg(enem_grafs[0][cte_mina]);
            unload_fpg(enem_grafs[1][cte_volador1]);
            unload_fpg(enem_grafs[1][cte_flozat]);
            unload_fpg(enem_grafs[1][cte_glotz]);
            unload_fpg(enem_grafs[1][cte_canon]);
            unload_fpg(enem_grafs[1][cte_flerris]);
            unload_fpg(enem_grafs[1][cte_s_flerrus]);
            
            enem_grafs[1][cte_guerrillero]=false;
            enem_grafs[1][cte_spider]=false;
            enem_grafs[1][cte_s_guerrillero]=false;
            enem_grafs[1][cte_zenerg]=false;
            enem_grafs[1][cte_mina]=false;
            enem_grafs[1][cte_volador1]=false;
            enem_grafs[1][cte_flozat]=false;
            enem_grafs[1][cte_glotz]=false;
            enem_grafs[1][cte_canon]=false;
            enem_grafs[1][cte_flerris]=false;
            enem_grafs[1][cte_s_flerrus]=false;*/
            
            stop_wav(-1);
            unload_wav(sfx_id[0][cte_sfx_shot]);
            
            sfx_id[1][cte_sfx_shot]=false;
            
            unset_interface();
            
            //main lines
            //search_start_point(&nivel,&durezas,0,&x2,&y2);
        end
        
        default: break; end
        end //switch
    end //loop principal
    
    unload_interface();
    if (exists(pausa_id)) signal(pausa_id,s_kill); end
    pausa_estado=0;
    
    unload_fpg(prota_file);
    unload_fpg(armas_file);
    unload_fpg(item_grafs);
    unload_fpg(explosion_grafs);
    //descarga de sonidos de disparo (si procede)
    if (disparo_wav[1][0])
        unload_wav(disparo_wav[0][0]);
        disparo_wav[1][0]=false;
    end
    if (disparo_wav[1][1])
        unload_wav(disparo_wav[0][1]);
        disparo_wav[1][1]=false;
    end
    if (disparo_wav[1][2])
        unload_wav(disparo_wav[0][2]);
        disparo_wav[1][2]=false;
    end
    signal(father,s_wakeup);
end
