function load_interface ()
private
    temp_fpg;
    temp_map;
    cont;
begin
    temp_fpg=load_fpg("grafs/interface.fpg");
    //copiamos los nmeros para poder usar luego map_put o similares
    for (cont=0;cont<10;cont++)
        interfaz_grafs[cont]=map_clone(temp_fpg,cont+1);
    end
    
    
    //creamos el cuadro esttico de la interfaz (no cambia, contiene nombres y las barras)
    interfaz_grafs[10]=new_map(244,17,16);
    set_center(0,interfaz_grafs[10],0,0);
    //colocamos los nombres
    temp_map=map_clone(temp_fpg,11);
    map_put(0,interfaz_grafs[10],temp_map,0,0);
    unload_map(0,temp_map);
    temp_map=map_clone(temp_fpg,12);
    map_put(0,interfaz_grafs[10],temp_map,0,9);
    unload_map(0,temp_map);
    //dibujamos las barras
    drawing_map(0,interfaz_grafs[10]);
    drawing_color(rgb(255,255,255));
    draw_rect(40,0,243,6);
    draw_rect(41,0,242,6);
    draw_rect(40,9,243,15);
    draw_rect(41,9,242,15);
    
    //y creamos los grficos que contienen los valores numricos
    interfaz_grafs[11]=map_clone(temp_fpg,13);
    interfaz_grafs[12]=map_clone(temp_fpg,13);
    interfaz_grafs[13]=map_clone(temp_fpg,14);
    
    //por ltimo, guardamos en memoria una copia de los smbolos de las armas
    interfaz_grafs[14]=map_clone(temp_fpg,21);
    interfaz_grafs[15]=map_clone(temp_fpg,22);
    interfaz_grafs[16]=map_clone(temp_fpg,23);
    
    //mapas para la energa del enemigo
    interfaz_grafs[17]=map_clone(temp_fpg,15);
    
    //mapas para el savegame
    interfaz_grafs[18]=map_clone(temp_fpg,18);
    interfaz_grafs[19]=map_clone(temp_fpg,19);
    
    unload_fpg(temp_fpg);
end

function refresh_interface_energy ()
private
    temp;
begin
    temp=(info_prota.p_energ*200)/info_prota.p_max_energ;
    //say(itoa(temp));
    drawing_map(0,interfaz_grafs[10]);
    if (temp>0)
        drawing_color(rgb(255,0,0));
        draw_box(42,1,41+temp,5);
    end
    if (temp<200)
        drawing_color(rgb(0,0,0));
        draw_box(42+temp,1,241,5);
    end
    //energia actual
    if (info_prota.p_energ<10)
        drawing_map(0,interfaz_grafs[11]);
        drawing_color(0);
        draw_box(0,0,7,7);
    else
        map_xput(0,interfaz_grafs[11],interfaz_grafs[info_prota.p_energ/10],0,0,0,100,128);
    end
    map_xput(0,interfaz_grafs[11],interfaz_grafs[info_prota.p_energ%10],6,0,0,100,128);
    //energia mxima
    if (info_prota.p_max_energ<10)
        map_xput(0,interfaz_grafs[11],interfaz_grafs[info_prota.p_max_energ],24,0,0,100,128);
        drawing_map(0,interfaz_grafs[11]);
        drawing_color(0);
        draw_box(18,0,24,7);
    else
        map_xput(0,interfaz_grafs[11],interfaz_grafs[info_prota.p_max_energ/10],18,0,0,100,128);
        map_xput(0,interfaz_grafs[11],interfaz_grafs[info_prota.p_max_energ%10],24,0,0,100,128);
    end
end

function refresh_interface_wexp()
private
    temp1;
    temp2;
    temp3;
begin
    if (armas_curr_level==0) temp1=0; else temp1=armas_level[armas_select][armas_curr_level]; end
    temp2=armas_level[armas_select][armas_curr_level+1];
    //calculamos el porcentaje
    temp3=((armas_level[armas_select][0]-temp1)*200)/(temp2-temp1);
    
    //pintamos la barra
    drawing_map(0,interfaz_grafs[10]);
    if (temp3>0)
        switch (armas_curr_level)
        case 0: drawing_color(rgb(0,0,255)); end
        case 1: drawing_color(rgb(0,128,255)); end
        case 2: drawing_color(rgb(117,217,255)); end
        end //switch
        draw_box(42,10,41+temp3,14);
    end
    if (temp3<200)
        switch (armas_curr_level)
        case 0: drawing_color(rgb(0,0,0)); end
        case 1: drawing_color(rgb(0,0,255)); end
        case 2: drawing_color(rgb(0,128,255)); end
        end //switch
        draw_box(42+temp3,10,241,14);
    end
    
    //pintamos energa actual
    temp3=armas_level[armas_select][0]-temp1;
    if (temp3<10)
        drawing_map(0,interfaz_grafs[12]);
        drawing_color(0);
        draw_box(0,0,7,7);
    else
        map_xput(0,interfaz_grafs[12],interfaz_grafs[temp3/10],0,0,0,100,128);
    end
    map_xput(0,interfaz_grafs[12],interfaz_grafs[temp3%10],6,0,0,100,128);
    //pintamos max energa del nivel
    temp3=temp2-temp1;
    if (temp3<10)
        map_xput(0,interfaz_grafs[12],interfaz_grafs[temp3],24,0,0,100,128);
        drawing_map(0,interfaz_grafs[12]);
        drawing_color(0);
        draw_box(16,0,24,7);
    else
        map_xput(0,interfaz_grafs[12],interfaz_grafs[temp3/10],16,0,0,100,128);
        map_xput(0,interfaz_grafs[12],interfaz_grafs[temp3%10],24,0,0,100,128);
    end
end

function refresh_weapons ()
private
    cont;
begin
    for (cont=1; cont<=3; cont++)
        if (armas_get[cont])
            armas_id[cont-1].graph=interfaz_grafs[13+cont];
            if (armas_select==cont) armas_id[cont-1].flags=0; else armas_id[cont-1].flags=4; end
        else
            armas_id[cont-1].graph=0;
        end
    end
end

function refresh_interface ()
begin
    refresh_interface_energy();
    refresh_interface_wexp();
    refresh_weapons();
end

function unload_interface ();
private
    cont;
begin
    for (cont=0;cont<=17;cont++)
        unload_map(0,interfaz_grafs[cont]);
    end
end

//**************************************************************************************************
//  PROCESOS QUE MUESTRAN LA INTERFAZ
//**************************************************************************************************

process interface_fix_image (graph,x,y,z)
begin
    //z=-5;
    signal(id,s_freeze);
    frame;
end

process interface_weap_image (x,y,z)
begin
    //z=-5;
    signal(id,s_freeze);
    frame;
end

function set_interface ()
begin
    interface_fix_image(interfaz_grafs[10],1,2,-6);
    interface_fix_image(interfaz_grafs[11],246,2,-6);
    interface_fix_image(interfaz_grafs[12],246,11,-6);
    interface_fix_image(interfaz_grafs[13],0,0,-5).flags=4;
    
    
    armas_id[0]=interface_weap_image(11,229,-5);
    armas_id[1]=interface_weap_image(35,229,-5);
    armas_id[2]=interface_weap_image(59,229,-5);
    
    refresh_weapons();
end

function unset_interface ()
private
    temp;
begin
    temp=get_id(type interface_fix_image);
    while (temp)
        signal(temp,s_kill);
        temp=get_id(type interface_fix_image);
    end
    
    temp=get_id(type interface_weap_image);
    while (temp)
        signal(temp,s_kill);
        temp=get_id(type interface_weap_image);
    end
end

//**************************************************************************************************
//  INTERFACES ESPECIALES
//**************************************************************************************************

process enem_ener_interface (eei_enem_id)
private
    int max_energia;
    
    int temp_map;
begin
    //creando cajetin
    graph=new_map(247,22,16);
    map_clear(file,graph,rgb(0,128,0));
    drawing_map(file,graph);
    drawing_color(0);
    draw_line(0,0,0,1);             //redondeo de esquina
    draw_line(0,0,1,0);
    drawing_color(rgb(0,212,0));     //brillo del borde
    draw_line(2,0,247,0);
    draw_line(1,1,247,1);
    draw_line(2,2,2,2);
    draw_line(0,2,0,22);
    draw_line(1,2,1,22);
    set_center(file,graph,0,0);
    map_put(0,graph,interfaz_grafs[17],6,8);    //escribiendo "enemigo"
    drawing_color(1);                //hueco de energias
    draw_box(41,7,243,15);
    drawing_color(rgb(0,96,0));
    draw_line(40,6,244,6);
    draw_line(40,6,40,15);
    drawing_color(rgb(0,212,0));
    draw_line(40,16,244,16);
    draw_line(244,8,244,16);
    x=73;
    y=240;
    z=-2;
    //flags=4;
    
    energia=eei_enem_id.energia;
    drawing_color(rgb(255,255,0));
    draw_box(42,9,242,13);
    
    while (y>218)
        y--;
        frame;
    end
    max_energia=energia;
    
    while (exists(info_prota.id_prota) && exists(eei_enem_id))
        if (eei_enem_id.energia!=energia)
            if (eei_enem_id.energia>0)
                energia=(eei_enem_id.energia*200)/max_energia;
            else
                energia=1;
            end
            drawing_map(file,graph);
            drawing_color(rgb(255,255,0));
            draw_box(42,9,42+energia,13);
            drawing_color(1);
            draw_box(42+energia+1,9,242,13);
            energia=eei_enem_id.energia;
        end
        if ((info_prota.id_prota.x>=x) && (info_prota.id_prota.y>=y))
            flags=4;
        else flags=0; end
        
        frame;
    end
    
    while (y<240)
        y++;
        frame;
    end
    unload_map(file,graph);
end
