process new_weapon_img (file,graph,x,y,z,size,region)
begin
    //z=-15;
    signal(id,s_freeze);
    frame;
end

process new_weapon_img2 (file,graph,x,y,z)
begin
    while (alpha>0)
        alpha-=10;
        size+=2;
        frame;
    end
end
//***************************************************************************
//  FUNCIONES DE ITEMS
//***************************************************************************
function cambiar_exp_arma (energia)
begin
    armas_level[armas_select][0]+=energia;
    if (energia>0)
        if (armas_level[armas_select][0]>=armas_level[armas_select][3])
            armas_level[armas_select][0]=armas_level[armas_select][3];
        else
            if (armas_level[armas_select][0] >= (armas_level[armas_select][armas_curr_level+1]))
                armas_curr_level++;
            end
        end
    end
    if (energia<0)
        if (armas_level[armas_select][0]<0)
            armas_level[armas_select][0]=0;
        else
            if (armas_level[armas_select][0] < (armas_level[armas_select][armas_curr_level]))
                armas_curr_level--;
            end
        end
    end
    refresh_interface_wexp();
end

//***************************************************************************
//  PROCESOS GRFICOS DE ITEMS
//***************************************************************************

process shot_exp (x2, y2, energia, int vel_horiz)
private
    int item_gravedad;
    int item_max_gravedad;
    int item_lifetime;
    
    int x3,y3;
    int resolution3;
    int vel_horiz_ant;
    int vel_vert;
    //variables para la deteccin de durezas
    int enem_dur[2][2];
    int enem_tilex, enem_tiley;
    int enem_offsx, enem_offsy;
    int enem_mover_h, enem_mover_v;
    int enem_p_dir, enem_p_dir_ini;
    int enem_estado;
    int p_libre;
begin
    priority=-99;
    file=item_grafs;
    graph=1;
    if (energia >= 5) graph++; end
    if (energia >= 10) graph++; end
    
    item_gravedad=1;
    item_max_gravedad=20;
    item_lifetime=750;
    resolution3=10;
    
    //say("x2,y2: "+itoa(x2)+" "+itoa(y2));
    
    x3=x2*resolution3;
    switch (graph)
    case 1: y3=(y2+6)*resolution3; end
    case 2: y3=(y2+5)*resolution3; end
    case 3: y3=(y2+4)*resolution3; end
    end //switch
    
    vel_horiz_ant=vel_horiz;
    enem_estado=3;
    
    /*write_int(0,10,10,0,&enem_dur[0][0]);
    write_int(0,10,20,0,&enem_dur[0][1]);
    write_int(0,10,30,0,&enem_dur[0][2]);
    write_int(0,30,10,0,&enem_dur[1][0]);
    write_int(0,30,20,0,&enem_dur[1][1]);
    write_int(0,30,30,0,&enem_dur[1][2]);
    write_int(0,50,10,0,&enem_dur[2][0]);
    write_int(0,50,20,0,&enem_dur[2][1]);
    write_int(0,50,30,0,&enem_dur[2][2]);*/
    
    loop
        vel_vert+=item_gravedad;
        if (vel_vert > item_max_gravedad) vel_vert=item_max_gravedad; end
        angle-=vel_horiz*1000;
        
        //DETECCION DE DUREZAS
        //localizamos la posicin actual
        enem_tilex= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        enem_tiley= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        enem_offsx= (x3/resolution3)%id_tscroll.tmapa[0].ancho_tile;
        enem_offsy= (y3/resolution3)%id_tscroll.tmapa[0].alto_tile;
        //leemos durezas de su alrededor
        enem_dur[0][0]=obtener_tile(&durezas,enem_tilex-1,enem_tiley-1,0);
        enem_dur[1][0]=obtener_tile(&durezas,enem_tilex  ,enem_tiley-1,0);
        enem_dur[2][0]=obtener_tile(&durezas,enem_tilex+1,enem_tiley-1,0);
        enem_dur[0][1]=obtener_tile(&durezas,enem_tilex-1,enem_tiley  ,0);
        enem_dur[1][1]=obtener_tile(&durezas,enem_tilex  ,enem_tiley  ,0);
        enem_dur[2][1]=obtener_tile(&durezas,enem_tilex+1,enem_tiley  ,0);
        enem_dur[0][2]=obtener_tile(&durezas,enem_tilex-1,enem_tiley+1,0);
        enem_dur[1][2]=obtener_tile(&durezas,enem_tilex  ,enem_tiley+1,0);
        enem_dur[2][2]=obtener_tile(&durezas,enem_tilex+1,enem_tiley+1,0);
        //comprobamos si cambiamos de tile y en que direccion
        //***************************************************************
        enem_mover_h=0;
        if (((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))!=enem_tilex)
           //comprobamos si pasamos a otro tile lateral y cuan lejos esta
           enem_mover_h=((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))-enem_tilex;
        end
        
        enem_mover_v=0;
        if (((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))!=enem_tiley)
           //comprobamos si pasamos a otro tile vertical y cuan lejos esta
           enem_mover_v=((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))-enem_tiley;
        end
         //miramos en que direccion cambiamos
        enem_p_dir=5;
        if (enem_mover_h>0) enem_p_dir++; end
        if (enem_mover_h<0) enem_p_dir--; end
        if (enem_mover_v>0) enem_p_dir-=3; end      //hacia abajo
        if (enem_mover_v<0) enem_p_dir+=3; end      //hacia arriba
        enem_p_dir_ini=enem_p_dir;
        
        include "durezas_check.inc";
        
        if (vel_horiz==0) vel_horiz=-vel_horiz_ant; end
        vel_horiz_ant=-vel_horiz_ant;
        if (enem_estado==0)
            vel_vert=-20;
            enem_estado=3;
        end
        
        switch (graph)
        case 1: y2=(y3/resolution3)-6; end
        case 2: y2=(y3/resolution3)-5; end
        case 3: y2=(y3/resolution3)-4; end
        end //switch
        //y2=y3/resolution3;
        x2=x3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        
        if (collision(type prota) || collision(type prota_moto))
            cambiar_exp_arma(energia);
            break;
        end
        
        //tiempo de vida (desaparece al rato)
        item_lifetime--;
        if (item_lifetime < 127) alpha=2*item_lifetime; end
        if (item_lifetime==0) break; end
        frame;
    end
end

process item_energy (x2,y2,energia)
private
    cont;
begin
    priority=-99;
    file=item_grafs;
    if (energia <=5) graph=4;
    elsif (energia <= 15) graph=5;
    else graph=6;
    end
    
    y2+=8-(y2%id_tscroll.tmapa[0].alto_tile);
    loop
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        if (collision (type prota) || collision(type prota_moto))
            info_prota.p_energ+=energia;
            if (info_prota.p_energ > info_prota.p_max_energ)
                info_prota.p_energ=info_prota.p_max_energ;
            end
            refresh_interface_energy();
            break;
        end
        
        cont++;
        if (cont >= 750) break; end
        
        frame;
    end
end

process item_add_energy (x3,y3)
private
    int hijos;
    int temp1,temp2;
    int cont;
begin
    priority=-99;
    file=item_grafs;
    graph=30;
    
    modificar_tile(&nivel,x3,y3,0,0);
    x2=(x3*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(y3*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile-1);
    
    loop
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        if (exists(info_prota.id_prota))
            //if ( (collision(info_prota.id_prota)) && (teclas[k_down][2]==1) )
            if ( (abs(info_prota.id_prota.x-x)<6) && (abs(info_prota.id_prota.y-y)<10) && (teclas[k_down][2]==1) )
                break;
            end
        end
        frame;
    end
    
    graph=0;
    //pausamos todo
    prota_control=false;
    signal(info_prota.id_prota,s_freeze_tree);
    signal_moving_items(s_freeze);
    signal_enemigos(s_freeze);
    
    //say("pausado");
    //fanfarria
    for (cont=global_vol;cont>=0;cont-=2) set_song_volume(cont); frame; end
    pause_song();
    
    //say("musica fuera");
    enem_grafs[0][cte_event]=load_fpg("grafs/eget.fpg");
    enem_grafs[1][cte_event]=true;
    
    //say("graf cargado");
    temp1=load_wav("music/ener_fanfare.wav");
    temp2=play_wav(temp1,0);
    
    //say("sonando musica");
    file=0;
    graph=new_map(320,50,16);
    map_clear(file,graph,1);
    x=480;
    y=120;
    z=-10;
    size_y=16;
    for (x=480;x>160;x-=10) frame; end
    for (size_y=16;size_y<100;size_y+=6)
        //say("contador 1: "+itoa((255*size_y)/100));
        map_clear(file,graph,rgb((255*size_y)/100,(255*size_y)/100,(255*size_y)/100) );
        frame;
    end
    size_y=100;
    for (cont=255;cont>0;cont-=18)
        //say("contador 2: "+itoa(cont));
        map_clear(file,graph,rgb(cont,cont,cont) );
        frame;
    end
    map_clear(file,graph,1);
    
    hijos=new_weapon_img(enem_grafs[0][cte_event],1,320,98,-11,100,0);
    for (hijos.x=320;hijos.x>-853;hijos.x-=10) frame; end
    
    while (is_playing_wav(temp2)) frame; end
    unload_wav(temp1);
    signal(hijos,s_kill);
    
    frame(5000);
    
    for (size_y=100;size_y>0;size_y-=6)
        map_clear(file,graph,rgb((255*size_y)/100,(255*size_y)/100,(255*size_y)/100) );
        frame;
    end
    unload_map(file,graph);
    
    resume_song();
    for (cont=0;cont<=global_vol;cont+=2) set_song_volume(cont); frame; end
    //aumentamos energa
    info_prota.p_max_energ+=2;
    info_prota.p_energ+=2;
    refresh_interface_energy();
    //quitamos pausa
    unload_fpg(enem_grafs[0][cte_event]);
    enem_grafs[1][cte_event]=false;
    
    prota_control=true;
    signal(info_prota.id_prota,s_wakeup_tree);
    signal_moving_items(s_wakeup);
    signal_enemigos(s_wakeup);
end

process new_weapon (x3,y3,energia)
private
    int nw_hijos[4];
    
    int nw_echox,nw_echoy;
    int temp;
    int temp_weap;
    //int temp_flags;
begin
    priority=-99;
    file=item_grafs;
    
    switch (energia)
    case 0: graph=21; end
    case 1: graph=22; end
    case 2: graph=23; end
    end //switch
    
    modificar_tile(&nivel,x3,y3,0,0);
    x2=(x3*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(y3*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
    
    loop
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        if (exists(info_prota.id_prota))
            //if ( (collision(info_prota.id_prota)) && (teclas[k_down][2]==1) )
            if ( (abs(info_prota.id_prota.x-x)<6) && (abs(info_prota.id_prota.y-y)<10) && (teclas[k_down][2]==1) )
                break;
            end
        end
        frame;
    end
    
    temp_weap=graph;
    //pausamos todo
    prota_control=false;
    signal(info_prota.id_prota,s_freeze_tree);
    signal(get_id(type arma),s_sleep);
    signal_moving_items(s_freeze);
    signal_enemigos(s_freeze);
    //oscurecemos pantalla
    alpha=0;
    file=0;
    graph=new_map(320,240,16);
    map_clear(file,graph,1);
    set_center(file,graph,0,0);
    x=0;
    y=0;
    z=-10;
    info_prota.id_prota.z=-11;
    
    //fade_music_off(2500);
    level_song=0;
    for (alpha=0;alpha<150;alpha++)
        frame;
    end
    
    //unload_song(level_song);
    //temp_flags=info_prota.id_prota.flags;
    info_prota.id_prota.graph=30;
    info_prota.id_prota.flags=0;
    info_prota.id_prota.z=1;
    
    //fanfarria
    //play_level_music(100);
    level_song=100;
    enem_grafs[0][cte_event]=load_fpg("grafs/wget.fpg");
    enem_grafs[1][cte_event]=true;
    nw_hijos[0]=new_weapon_img (enem_grafs[0][cte_event],1,info_prota.id_prota.x,info_prota.id_prota.y-8,-15,
                                25,0);
    while ((nw_hijos[0].x!=150) || (nw_hijos[0].y!=75))
        if (nw_hijos[0].x<150) nw_hijos[0].x++; end
        if (nw_hijos[0].x>150) nw_hijos[0].x--; end
        if (nw_hijos[0].y<75) nw_hijos[0].y++; end
        if (nw_hijos[0].y>75) nw_hijos[0].y--; end
        if (nw_hijos[0].size<100) nw_hijos[0].size++; end
        frame;
    end
    while (nw_hijos[0].size<100)
        nw_hijos[0].size++;
        frame;
    end
    
    nw_hijos[1]=new_weapon_img (enem_grafs[0][cte_event],5,160,135,-15,100,2);
    //define_region(2,75,127,174,16);
    temp=18;
    while (temp<200)
        temp+=2;
        switch(temp)
        case 20,40,60,80,94,114,134,154,174: define_region(2,75,127,temp,16); end
        end //switch
        frame;
    end
    nw_hijos[2]=new_weapon_img (enem_grafs[0][cte_event],energia+2,196,48,-16,100,0);
    new_weapon_img2 (enem_grafs[0][cte_event],energia+2,196,48,-16);
    
    nw_hijos[3]=new_weapon_img (enem_grafs[0][cte_event],energia+6,160,190,-15,100,0);
    nw_hijos[4]=new_weapon_img (enem_grafs[0][cte_event],energia+9,160,190,-16,100,0);
    nw_hijos[4].alpha=0;
    temp=0;
    energia=30000;
    loop
        temp+=energia;
        if (temp>360000)
            temp-=360000;
            energia=energia>>1;
        end
        nw_hijos[3].size_y=abs(100*sin(temp));
        if (sin(temp)<0) nw_hijos[3].flags=2; else nw_hijos[3].flags=0; end
        if ((energia<2000) && (nw_hijos[3].size_y==100) && (nw_hijos[3].flags==0)) break; end
        frame;
    end
    
    for (nw_hijos[4].alpha=0;nw_hijos[4].alpha<255;nw_hijos[4].alpha+=32) frame; end
    for (nw_hijos[4].alpha=255;nw_hijos[4].alpha>0;nw_hijos[4].alpha-=32) frame; end
    nw_hijos[4].alpha=0;
        
    while (is_playing_song()) frame; end
    frame(10000);
    //aadimos el arma
    switch (temp_weap)
    case 21: armas_get[0]=false; armas_get[1]=true; end
    case 22: armas_get[0]=false; armas_get[2]=true; end
    case 23: armas_get[0]=false; armas_get[3]=true; end
    end //switch
    refresh_weapons();
    //aclaramos la pantalla
    signal(nw_hijos[0],s_kill);
    signal(nw_hijos[1],s_kill);
    signal(nw_hijos[2],s_kill);
    signal(nw_hijos[3],s_kill);
    signal(nw_hijos[4],s_kill);
    for (alpha=150;alpha>0;alpha-=2)
        frame;
    end
    //quitamos pausa
    signal(info_prota.id_prota,s_wakeup_tree);
    prota_control=true;
    signal_moving_items(s_wakeup);
    signal_enemigos(s_wakeup);
    unload_map(file,graph);
    unload_fpg(enem_grafs[0][cte_event]);
    enem_grafs[1][cte_event]=false;
    
    //play_level_music(next_level);
    level_song=next_level;
end

//***************************************************************************
//  FUNCION PRINCIPAL GENERA ALEATORIO ITEM
//***************************************************************************

function random_item (energia,x2,y2)
private
    temp_ener;
    temp_exp;
    temp;
    ri_rangos[2];
begin
    if (info_prota.p_energ > 0)
        //calculamos el porcentaje de vida restante
        temp_ener=(info_prota.p_energ*100)/info_prota.p_max_energ;
        temp_exp =(armas_level[armas_select][0]*100)/armas_level[armas_select][3];
        //say("% energia: "+itoa(temp_ener));
        //say("% arma: "+itoa(temp_exp));
        ri_rangos[0]=2*(100-temp_ener);
        ri_rangos[1]=ri_rangos[0]+100-temp_exp;
        //say("rangos: "+itoa(ri_rangos[0])+","+itoa(ri_rangos[1])+","+itoa(ri_rangos[1]*1.1)+";");
        temp=rand(0,ri_rangos[1]*1.1);
        //say("valor aleatorio: "+itoa(temp));
        if (temp < ri_rangos[0])
            //generando energa
            ri_rangos[0]=temp_ener;
            if (ri_rangos[0]>33) ri_rangos[0]=33; end
            
            if (temp_ener>33) ri_rangos[1]=temp_ener-33; else ri_rangos[1]=0; end
            if (ri_rangos[1]>33) ri_rangos[1]=33; end
            ri_rangos[1]=(ri_rangos[1]*2)+ri_rangos[0];
            
            if (temp_ener>66) ri_rangos[2]=temp_ener-66; else ri_rangos[2]=0; end
            if (ri_rangos[2]>33) ri_rangos[2]=33; end
            ri_rangos[2]=(ri_rangos[2]*3)+ri_rangos[1];
            
            temp_ener=rand(0,ri_rangos[2]);
            temp_exp=3;
            if ((temp_ener > ri_rangos[0]) && (energia>=5)) temp_exp=5; end
            if ((temp_ener > ri_rangos[1]) && (energia>=15)) temp_exp=15; end
            item_energy(x2,y2,temp_exp);
        elsif ((temp >= ri_rangos[0]) && (temp < ri_rangos[1]))
            //generando exp arma
            if (rand(0,100) < 33) energia=energia/2; end
            while (energia > 0)
                if (energia >= 10)
                    shot_exp(x2,y2,10,rand(-15,15));
                    energia-=10;
                elsif (energia >= 5)
                    shot_exp(x2,y2,5,rand(-15,15));
                    energia-=5;
                else
                    shot_exp(x2,y2,2,rand(-15,15));
                    energia-=2;
                end
            end
        else
            //truo
        end
    end
end

//***************************************************************************
//  ITEMS ESPECIALES: FIN DE PANTALLA Y NIVEL
//***************************************************************************

process item_end_sublevel (x3,y3)
begin
    modificar_tile(&nivel,x3,y3,0,0);
    //file=item_grafs;
    //graph=51;
    
    x2=(x3*id_tscroll.tmapa[0].ancho_tile)+(id_tscroll.tmapa[0].ancho_tile/2);
    y2=(y3*id_tscroll.tmapa[0].alto_tile)+(id_tscroll.tmapa[0].alto_tile/2);
    
    loop
        if (exists(info_prota.id_prota))
            //if (collision(info_prota.id_prota)) break; end
            if ( (abs(info_prota.id_prota.x2-x2)<(id_tscroll.tmapa[0].ancho_tile/2)) &&
                 (abs(info_prota.id_prota.y2-y2)<(id_tscroll.tmapa[0].alto_tile/2))   )
                break;
            end
        end
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    pausa_estado=0;
    prota_control=false;
    if (exists(info_prota.id_prota)) signal(info_prota.id_prota,s_freeze_tree); end
    signal_moving_items(s_freeze);
    signal_enemigos(s_freeze);
    
    fade(0,0,0,3);
    while (fading) frame; end
    
    next_sublevel=obtener_tile(&durezas,x3,y3,0)-150;
    
    if (savegame_pos!=0)
        refresh_actual_gamedata(&game_global_sav);
        save_filegame(&game_global_sav,savegame_pos);
        game_saved_graph();
    end
    
    end_level=true;
end

process item_end_level (x3,y3)
begin
    modificar_tile(&nivel,x3,y3,0,0);
    file=item_grafs;
    graph=52;
    //alpha=0;
    
    x2=(x3*id_tscroll.tmapa[0].ancho_tile)+(id_tscroll.tmapa[0].ancho_tile/2);
    y2=(y3*id_tscroll.tmapa[0].alto_tile)+(id_tscroll.tmapa[0].alto_tile/2);
    
    loop
        if (exists(info_prota.id_prota))
            //if (collision(info_prota.id_prota)) break; end
            if ( (abs(info_prota.id_prota.x2-x2)<(id_tscroll.tmapa[0].ancho_tile/2)) &&
                 (abs(info_prota.id_prota.y2-y2)<(id_tscroll.tmapa[0].alto_tile/2))   )
                break;
            end
        end
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    next_level=obtener_tile(&durezas,x3,y3,0)-150;
    //say(next_level);
    end_level=true;
end
