function load_filegame (savegame pointer lf_data, int n)
private
    string lf_file_name;
    int lf_file_id;
    int lf_data_readed;
    int dato_a_devolver;
begin
    lf_file_name="save/data0"+itoa(n)+".sav";
    if (file_exists(lf_file_name))
        lf_file_id=fopen(lf_file_name,o_read);
        lf_data_readed=fread(lf_file_id,*lf_data);
        //say(itoa(lf_data_readed));
        if (lf_data_readed!=sizeof(savegame))
            dato_a_devolver=2;
        end
        
        fclose(lf_file_id);
    else
        dato_a_devolver=1;
    end
    
    return (dato_a_devolver);   //1: fichero no encontrado
                                //2: tamao incorrecto
end

function save_filegame (savegame pointer sf_data, int n)
private
    string sf_file_name;
    int sf_file_id;
    int sf_data_readed;
    int dato_a_devolver;
begin
    sf_file_name="save/data0"+itoa(n)+".sav";
    
    sf_file_id=fopen(sf_file_name,o_write);
    sf_data_readed=fwrite(sf_file_id,*sf_data);
    //say(itoa(sf_data_readed));
    if (sf_data_readed!=sizeof(savegame))
        dato_a_devolver=2;
    end
    
    fclose(sf_file_id);
    
    return (dato_a_devolver);   //1: fichero no encontrado
                                //2: tamao incorrecto
end

//**************************************************************************
//  ESTRUCTURAS PARA EL JUEGO
//**************************************************************************

function refresh_actual_gamedata (savegame pointer rag_data)
private
    int cont1, cont2;
begin
    rag_data.level=next_level;
    switch (rag_data.level)
    case 1: rag_data.sublevel=next_sublevel; end
    case 3: rag_data.sublevel=init_level; end
    end //switch
    
    rag_data.difficulty=dificultad;
    rag_data.lives=info_prota.vidas;
    
    rag_data.armas=1;
    if (armas_get[1]) rag_data.armas=2; end
    if (armas_get[2]) rag_data.armas+=4; end
    if (armas_get[3]) rag_data.armas+=8; end
    
    rag_data.max_energ=info_prota.p_max_energ;
    rag_data.energ=info_prota.p_energ;
    
    for (cont2=0;cont2<=3;cont2++)
        for (cont1=0;cont1<=3;cont1++)
            rag_data.armas_level[cont2][cont1]=armas_level[cont2][cont1];
        end
    end
end

function load_actual_gamedata (savegame pointer lag_data)
private
    int cont1, cont2;
begin
    next_level=lag_data.level;
    switch (lag_data.level)
    case 1: next_sublevel=lag_data.sublevel; init_level=0; end
    case 3: init_level=lag_data.sublevel; next_sublevel=0; end
    end //switch
    
    dificultad=lag_data.difficulty;
    info_prota.vidas=lag_data.lives;
    
    if ((lag_data.armas &1)==1) armas_get[0]=true; else armas_get[0]=false; end
    if ((lag_data.armas &2)==2) armas_get[1]=true; else armas_get[1]=false; end
    if ((lag_data.armas &4)==4) armas_get[2]=true; else armas_get[2]=false; end
    if ((lag_data.armas &8)==8) armas_get[3]=true; else armas_get[3]=false; end
    
    info_prota.p_max_energ=lag_data.max_energ;
    info_prota.p_energ=lag_data.energ;
    
    init_weapons();
    for (cont2=0;cont2<=3;cont2++)
        for (cont1=0;cont1<=3;cont1++)
            armas_level[cont2][cont1]=lag_data.armas_level[cont2][cont1];
        end
    end
end

function load_default_gamedata (savegame pointer ldg_data, int ldg_dificultad, int ldg_vidas)
private
    int cont1, cont2;
begin
    ldg_data.level=1;
    ldg_data.sublevel=0;
    
    ldg_data.difficulty=ldg_dificultad;
    ldg_data.lives=ldg_vidas;
    
    ldg_data.armas=1;
    
    ldg_data.max_energ=10;
    ldg_data.energ=10;
    
    armas_level[0][0]=0;
    armas_level[1][0]=0;
    armas_level[2][0]=0;
    armas_level[3][0]=0;
    init_weapons();
    
    for (cont2=0;cont2<=3;cont2++)
        for (cont1=0;cont1<=3;cont1++)
            ldg_data.armas_level[cont2][cont1]=armas_level[cont2][cont1];
        end
    end
end

//*******************************************************************************
//  SELECT FILE MENU
//*******************************************************************************
function get_sfm_graph (savegame pointer ptr_sav, int temp, int gsg_font,
                        int graph1, int graph2, int graph3, int graph4)
private
    int final_graph;
    int temp_graph;
    
    string temp_string;
begin
    final_graph=new_map(200,18,16);
    //escribiendo nmero de fichero
    temp_graph=write_in_map(gsg_font,itoa(temp)+".",6);
    map_put(file,final_graph,temp_graph,0,14);
    unload_map(0,temp_graph);
    
    //escribiendo nivel
    switch (ptr_sav.level)
    case 1: temp_string="Lvl 1-"+itoa(ptr_sav.sublevel+1); end
    case 3: temp_string="Lvl 2-"+itoa(ptr_sav.sublevel+1); end
    end //switch
    temp_graph=write_in_map(gsg_font,temp_string,6);
    map_put(file,final_graph,temp_graph,22,14);
    unload_map(0,temp_graph);
    
    //escribiendo dificultad
    switch (ptr_sav.difficulty)
    case 0: temp_string="Easy"; end
    case 1: temp_string="Medium"; end
    case 2: temp_string="Hard"; end
    end //switch
    temp_graph=write_in_map(gsg_font,temp_string,6);
    map_put(file,final_graph,temp_graph,72,14);
    unload_map(0,temp_graph);
    
    if ((ptr_sav.armas & 2)==2) map_put(file,final_graph,graph1,127,9); end
    if ((ptr_sav.armas & 4)==4) map_put(file,final_graph,graph2,139,9); end
    if ((ptr_sav.armas & 8)==8) map_put(file,final_graph,graph3,151,9); end
    
    map_put(file,final_graph,graph4,169,16);
    temp_graph=write_in_map(gsg_font,"x "+itoa(ptr_sav.lives),6);
    map_put(file,final_graph,temp_graph,180,14);
    unload_map(0,temp_graph);
    
    return (final_graph);
end

process select_file_menu_img (file,graph,x,y,z)
begin
    signal(id,s_freeze);
    frame;
end

process select_file_menu (max_opcion,load_menu)
private
    int gm_font;
    int gm_ancho_map,gm_alto_map;
    
    int gm_text[0];
    int gm_graph[10];
    int gm_hijos[11];
    
    savegame temp_sav;
    int temp_map[3];
    int file2;
    int temp;
    int cont;
begin
    gm_font=load_fnt("fonts/menu1.fnt");
    gm_ancho_map=200;
    
    gm_ancho_map+=20;
    gm_alto_map=20*(max_opcion+2)+30;
    
    graph=new_map(gm_ancho_map,gm_alto_map,16);
    map_clear(file,graph,1);
    drawing_map(file,graph);
    drawing_color(rgb(255,255,255));
    draw_rect(0,0,gm_ancho_map-1,gm_alto_map-1);
    draw_rect(1,1,gm_ancho_map-2,gm_alto_map-2);
    
    draw_line(2,2,5,2);
    draw_line(2,3,3,3);
    draw_line(2,4,2,5);
    
    draw_line(gm_ancho_map-3,2,gm_ancho_map-3-3,2);
    draw_line(gm_ancho_map-3,3,gm_ancho_map-3-1,3);
    draw_line(gm_ancho_map-3,4,gm_ancho_map-3-0,5);
    
    draw_line(2,gm_alto_map-3,5,gm_alto_map-3);
    draw_line(2,gm_alto_map-4,3,gm_alto_map-4);
    draw_line(2,gm_alto_map-5,2,gm_alto_map-6);
    
    draw_line(gm_ancho_map-3,gm_alto_map-3,gm_ancho_map-3-3,gm_alto_map-3);
    draw_line(gm_ancho_map-3,gm_alto_map-4,gm_ancho_map-3-1,gm_alto_map-4);
    draw_line(gm_ancho_map-3,gm_alto_map-5,gm_ancho_map-3-0,gm_alto_map-6);
    
    drawing_color(0);
    draw_line(0,0,5,0);
    draw_line(0,1,2,1);
    draw_line(0,2,1,2);
    draw_line(0,3,0,5);
    
    draw_line(gm_ancho_map-1,0,gm_ancho_map-1-5,0);
    draw_line(gm_ancho_map-1,1,gm_ancho_map-1-2,1);
    draw_line(gm_ancho_map-1,2,gm_ancho_map-1-1,2);
    draw_line(gm_ancho_map-1,3,gm_ancho_map-1-0,5);
    
    draw_line(0,gm_alto_map-1-0,5,gm_alto_map-1-0);
    draw_line(0,gm_alto_map-1-1,2,gm_alto_map-1-1);
    draw_line(0,gm_alto_map-1-2,1,gm_alto_map-1-2);
    draw_line(0,gm_alto_map-1-3,0,gm_alto_map-1-5);
    
    draw_line(gm_ancho_map-1,gm_alto_map-1-0,gm_ancho_map-1-5,gm_alto_map-1-0);
    draw_line(gm_ancho_map-1,gm_alto_map-1-1,gm_ancho_map-1-2,gm_alto_map-1-1);
    draw_line(gm_ancho_map-1,gm_alto_map-1-2,gm_ancho_map-1-1,gm_alto_map-1-2);
    draw_line(gm_ancho_map-1,gm_alto_map-1-3,gm_ancho_map-1-0,gm_alto_map-1-5);
    
    x=160;
    y=120;
    z=-100;

    //carga de copia de grficos para representar las armas que se tienen y el nmero de vidas
    file2=load_fpg("grafs/items.fpg");
    temp_map[0]=map_clone(file2,21);
    temp_map[1]=map_clone(file2,22);
    temp_map[2]=map_clone(file2,23);
    unload_fpg(file2);
    file2=load_fpg("grafs/prota.fpg");
    temp_map[3]=map_clone(file2,36);
    unload_fpg(file2);
    
    //generamos los mapas de cada linea
    gm_text[0]=write(gm_font,160,y-(gm_alto_map/2)+14,4,"SELECT FILE");
    for (cont=1;cont<=max_opcion;cont++)
        temp=load_filegame(&temp_sav,cont);
        switch (temp)
        case 0:         //sin problemas
            gm_graph[cont]=get_sfm_graph(&temp_sav,cont,gm_font,temp_map[0],temp_map[1],temp_map[2],temp_map[3]);
        end
        case 1:         //no encontrado
            gm_graph[cont]=new_map(200,18,16);
            
            temp=write_in_map(gm_font,itoa(cont)+".  -Empty-",6);
            map_put(file,gm_graph[cont],temp,0,14);
            unload_map(0,temp);
        end
        end
    end
    
    if (load_menu)
        gm_graph[0]=new_map(200,18,16);
        temp=write_in_map(gm_font,"Cancel.",6);
        map_put(file,gm_graph[0],temp,0,14);
        unload_map(0,temp);
    else
        gm_graph[0]=new_map(200,18,16);
        temp=write_in_map(gm_font,"No save.",6);
        map_put(file,gm_graph[0],temp,0,14);
        unload_map(0,temp);
    end
    
    //creamos los procesos que llevan cada imagen
    for (cont=0;cont<=max_opcion;cont++)
        gm_hijos[cont]=select_file_menu_img(0,gm_graph[cont],160,y-(gm_alto_map/2)+14+(20*(cont+2)),z-2);
    end
    
    gm_hijos[11]=select_file_menu_img (0,new_map(gm_ancho_map-10,20,16),160,y-(gm_alto_map/2)+14,z-1);
    map_clear(file,gm_hijos[11].graph,rgb(0,0,128));
    
    //empieza el control del menu
    global_opt=0;
    gm_hijos[11].y=y-(gm_alto_map/2)+14+40+(global_opt*20);
    loop
        if (teclas[k_up][2]==1)
            if (global_opt==0) global_opt=max_opcion; else global_opt--; end
            gm_hijos[11].y=y-(gm_alto_map/2)+14+40+(global_opt*20);
        end
        if (teclas[k_down][2]==1)
            if (global_opt==max_opcion) global_opt=0; else global_opt++; end
            gm_hijos[11].y=y-(gm_alto_map/2)+14+40+(global_opt*20);
        end
        if (teclas[k_enter][2]==1)
            if (load_menu)          //para cargar el fichero seleccionado debe existir
                if (global_opt==0)  //y no debemos haber seleccionado "cancel"
                    break;
                else
                    if (savegame_exists_file[global_opt-1]) break; end
                end
            else                    //si no, no
                break;
            end
        end
        frame;
    end
    
    savegame_pos=global_opt;
    
    for (cont=0;cont<1;cont++)
        if (gm_text[cont]!=0) delete_text(gm_text[cont]); end
    end
    for (cont=0;cont<4;cont++)
        unload_map(0,temp_map[cont]);
    end
    for (cont=0;cont<=max_opcion;cont++)
        unload_map(0,gm_graph[cont]);
    end
    unload_map(0,gm_hijos[11].graph);
    unload_fnt(gm_font);
    for (cont=0;cont<=11;cont++)
        if (exists(gm_hijos[cont])) signal(gm_hijos[cont],s_kill); end
    end
end

function refresh_savegame_exists_file ()
private
    int cont;
begin
    for (cont=0;cont<max_savefiles;cont++)
        savegame_exists_file[cont]=file_exists("save/data0"+itoa(cont+1)+".sav");
    end
end

process game_saved_graph ()
private
    int cont;
    int cont_anim;
begin
    file=0;
    graph=interfaz_grafs[18];
    x=401;
    y=228;
    z=-11;
    while (x>319)
        x-=2;
        cont_anim++;
        switch (cont_anim)
        case 20: graph=interfaz_grafs[19]; end
        case 40: graph=interfaz_grafs[18]; cont_anim=0; end
        end //switch
        frame;
    end
    
    for (cont=0;cont<150;cont++)
        cont_anim++;
        switch (cont_anim)
        case 20: graph=interfaz_grafs[19]; end
        case 40: graph=interfaz_grafs[18]; cont_anim=0; end
        end //switch
        frame;
    end
    
    while (x<400)
        x+=2;
        cont_anim++;
        switch (cont_anim)
        case 20: graph=interfaz_grafs[19]; end
        case 40: graph=interfaz_grafs[18]; cont_anim=0; end
        end //switch
        frame;
    end
end
